webpackJsonp([6],{

/***/ 36:
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var common = __webpack_require__(1);

MC_Query = __webpack_require__(5);
Essay_Query = __webpack_require__(17);
CB_Query = __webpack_require__(15);
DD_Query = __webpack_require__(16);
FB_Query = __webpack_require__(18);
Question = __webpack_require__(19);
Interactions = __webpack_require__(14);
Figures = __webpack_require__(4);

var ProjectPlayer = __webpack_require__(3);

/*
document.write(
  '<link href="https://fonts.googleapis.com/css?family=Titillium+Web:700" rel="stylesheet" type="text/css">'
);
document.write(
  '<link href="https://fonts.googleapis.com/css?family=Titillium+Web:400" rel="stylesheet" type="text/css">'
);
*/

(function () {
  var style = document.createElement('link');
  style.type = 'text/css';
  style.rel = 'stylesheet';
  style.href = "https://fonts.googleapis.com/css?family=Titillium+Web:700";
  document.getElementsByTagName('head')[0].appendChild(style);
})();

(function () {
  var style = document.createElement('link');
  style.type = 'text/css';
  style.rel = 'stylesheet';
  style.href = "https://fonts.googleapis.com/css?family=Titillium+Web:400";
  document.getElementsByTagName('head')[0].appendChild(style);
})();

window.platform = __webpack_require__(0).run_on;
window.Local_Dialog = __webpack_require__(27);
window.player = new ProjectPlayer();

window.submit_hidden_arga_question = function () {
  safe_log('submit_hidden_arga_question()');
  var curr_sec = player.section_currently_showing;
  safe_log('current section = ' + curr_sec);
  var $sec = $('#digfir_section_' + curr_sec);
  var $question = $sec.find('[data-type="question"]');

  // there should only be 1 hidden question on the page and
  // no other arga questions
  safe_log('number of questions on slide: ' + $question.length);
  if ($question.length !== 1) {
    return;
  }

  // make sure this is a hidden question
  var $submit_button = $question.find('input[type="button"]');
  if (!$submit_button.length) {
    return;
  }

  safe_log('found submit button');

  var question_index = $question.attr('data-question_index');

  safe_log(player.activity.questions[question_index]);

  // only submit if the question hasn't been submitted already
  if (!player.activity.questions[question_index].is_complete()) {
    var query = player.activity.questions[question_index].queries[0];
    query.setUserAnswer('completed');
    //$submit_button.click();
    //safe_log('submitting hidden question answer (' + question_index + ')');
    player.activity.submit_question(question_index);
  }
  else {
    safe_log('hidden question has already been submitted');
    safe_log(player.activity.questions[question_index]);
  }
};

common.initForceNextSection();



/***/ }),

/***/ 84:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(36);


/***/ })

},[84]);
//# sourceMappingURL=kolb_nia_winter2019.js.map

var KEY_CODES = {
  ENTER: 13,
  TAB: 9,
  ESC: 27,
  SPACE: 32,
  LEFT: 37,
  RIGHT: 39
};

var Standard_Dialog = function() {
  var $manuscript = $('#manuscript');
  var $body = $('body');
  var $dialog, $content;
  var options = {};

  return {
    open: function(html, opt) {
      // Extend default options
      options = $.extend(true, {
        width: 450,
        modal: true,
        draggable: false,
        resizable: false,
        ariaLabelledby: null,
        ariaDescribedby: ''
      }, (opt || {}));

      // Set buttons
      if (options.buttons === 'none') {
        options.buttons = null;
      }
      else if (options.buttons === 'OK' || !options.buttons) {
        //options.buttons = [ { text: 'OK', click: Standard_Dialog.close } ];
      }

      safe_log('Standard_Dialog.open()');
      safe_log(options);

      // Remove previous dialog
      $('#standard_dialog_div').dialog('close').remove();

      if (options.modal) {
        $body.css('overflow', 'hidden');
      }

      // Hide other content from reader for mobile devices
      $manuscript.attr('aria-hidden', 'true');

      $dialog = $('<div id="standard_dialog_div"></div>');
      $content = $('<div class="dialog-div">' + (html || '') + '</div>');

      $dialog.append($content);
      $dialog.dialog(options);

      // If we open toc we use as description only instruction in the top of dialog and not links
      var isMenu = $content.find('#toc_head').length;
      var labelledByPart = isMenu ? 'toc_head' : 'standard_dialog_div';

      var labelledBy = options.ariaLabelledby === null ? 'ui-dialog-title-standard_dialog_div ' + labelledByPart : options.ariaLabelledby;

      // set so ugly, that don't break current functionality with aria-labelledby
      var $parentDialog = $dialog.parent().attr({
        'tabindex': '0',
        'role': 'dialog'
      });
      var _labeledBy = labelledBy;
      var _descrBy = options.ariaDescribedby;

      _labeledBy && $parentDialog.attr('aria-labelledby', _labeledBy);
      _descrBy && $parentDialog.attr('aria-describedby', _descrBy);

      $parentDialog.find('#ui-dialog-title-standard_dialog_div').attr({
        'role': 'heading',
        'aria-level': '1'
      });

      // Remove close btn
      $('.ui-dialog-titlebar-close').remove();

      var $lastBtn = $parentDialog.find('button').last();
      var $firstBtn = $parentDialog.find('button').first();

      // Attach events
      $parentDialog.bind('keydown', function(e) {
        var code = e.keyCode || e.which;

        if (code === KEY_CODES.ESC) {
          //safe_log(options);
          if (typeof options.buttons[0].click === 'function') {
            options.buttons[0].click();
          }
          else {
            Standard_Dialog.close(true);
          }
        }

        if (e.target === this && e.shiftKey && code === KEY_CODES.TAB) {
          e.preventDefault();
          $lastBtn.focus();
        }
      });
      $lastBtn.bind('keydown', function(e) {
        var code = e.keyCode || e.which;

        if (!e.shiftKey && code === KEY_CODES.TAB) {
          $parentDialog.focus();
          e.preventDefault();
        }
      });

      if (isMenu) {
        // If it is menu put focus on first link
        $parentDialog.find('a').first().focus();
      }
      else {
        // For other platform we set focus on first button
        $firstBtn.focus();
      }

      $(document.head).parent().css('overflow', 'hidden');
    },

    // for now alert is just like any other dialog; we could change that later.
    wait: function(html, opt) {
      options = opt || {};
      options.buttons = 'none';
      Standard_Dialog.open(html, options);
    },

    alert: function(html, opt) {
      Standard_Dialog.open(html, opt);
    },

    close: function() {
      // Show other content
      $manuscript.removeAttr('aria-hidden');

      if ($dialog) {
        $dialog.dialog('close').remove();
      }
      else {
        $("#standard_dialog_div").remove();
      }

      if (options.from) {
        options.from.focus();
      }

      if (options.modal) {
        $body.css('overflow', 'auto');
      }

      //$(document.head).parent().css('overflow', 'auto');
    }
  };
}();

var ArgaQueryText = ArgaQueryText || {};

var SaviBcHandlers = SaviBcHandlers || {};

SaviBcHandlers.ended_default = function(video_obj) {

    // set watched to true
    video_obj.watched = true;

    // get all videos in current section
    const video_objs = player.savi_bc_videos.getVideoObjsBySection(player.section_currently_showing);
    let ALL_VIDEOS_WATCHED = true;

    video_objs.forEach(function(video) {
        if (!video.watched) {
            ALL_VIDEOS_WATCHED = false;
        }
    });

    if (ALL_VIDEOS_WATCHED) {
        player.completeSectionTask();
    }
};

SaviBcHandlers.play_default = function(video_obj) {
    const video_objs = player.savi_bc_videos.getAllVideoObjs();
    video_objs.forEach(function(vid_obj) {
        if (vid_obj !== video_obj) {
            vid_obj.pause();
        }
    });
};