webpackJsonp([2],{

/***/ 29:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(38);

var ProjectPlayer = __webpack_require__(3);
var DoubleMatchingActivity = __webpack_require__(58);
var OrderActivity = __webpack_require__(60);
var ProjectFigures = __webpack_require__(4);

var CUSTOM_ACITIVITIES_PARAMS = {
  '2': {
    activityType: DoubleMatchingActivity,
    triesCount: 4,
    dndPartContainerSelector: '#digfir_section_2 [data-block_type="dnd-part"]',
    dragItemsContainerSelector: '#digfir_section_2 .drag-items',
    dropAreasContainerSelector: '#digfir_section_2 .matching-drop-areas-container',
    dndSettings: {
      possibleToReplaceDroppedItem: true,
      container: '#digfir_section_2 [data-type="rawhtml"] .match_test',
      bounds: '#digfir_section_2 [data-type="rawhtml"] .match_test',
      dragItems: [
        {
          node: '#first-matching-drag-item-1',
          data: 1,
          ariaLabel: 'Ca 2+ activated (binding) protein',
        },
        {
          node: '#first-matching-drag-item-2',
          data: 2,
          ariaLabel: 'microtubules',
        },
        {
          node: '#first-matching-drag-item-3',
          data: 3,
          ariaLabel: 'neurotransmitters',
        },
        {
          node: '#first-matching-drag-item-4',
          data: 4,
          ariaLabel: 'presynaptic membrane',
        },
        {
          node: '#first-matching-drag-item-5',
          data: 5,
          ariaLabel: 'synaptic vesicle',
        },
        {
          node: '#first-matching-drag-item-6',
          data: 6,
          ariaLabel: 'storage granule',
        },
        {
          node: '#first-matching-drag-item-7',
          data: 7,
          ariaLabel: 'transporter',
        },
        {
          node: '#first-matching-drag-item-8',
          data: 8,
          ariaLabel: 'voltage-gated Ca 2+ channel',
        }
      ],
      dropAreas: [
        {
          node: '#first-matching-drop-area-1',
          ariaLabel: 'Calcium molecule with a positive charge; protein that binds two or more molecules together.'
            + ' (In this case, binding proteins bind to the vesicles and the presynaptic membrane.)',
          data: 1,
        },
        {
          node: '#first-matching-drop-area-2',
          ariaLabel: 'Transport structures that carry substances to the axon terminal.',
          data: 2,
        },
        {
          node: '#first-matching-drop-area-3',
          ariaLabel: 'Chemicals that have an excitatory or inhibitory effect when released by a neuron onto a target.',
          data: 3,
        },
        {
          node: '#first-matching-drop-area-4',
          ariaLabel: 'A membrane that encloses molecules that transmit chemical messages.',
          data: 4,
        },
        {
          node: '#first-matching-drop-area-5',
          ariaLabel: 'A membranous compartment that encloses a fixed number of neurotransmitter molecules.',
          data: 5,
        },
        {
          node: '#first-matching-drop-area-6',
          ariaLabel: 'A membranous compartment that holds several vesicles containing a neurotransmitter.',
          data: 6,
        },
        {
          node: '#first-matching-drop-area-7',
          ariaLabel: 'A protein molecule that pumps substances across a membrane.',
          data: 7,
        },
        {
          node: '#first-matching-drop-area-8',
          ariaLabel: 'A gated protein channel on the presynaptic cell that opens when an action potential arrives'
            + ' at the axon terminal, allowing Ca2+ ions to flow into the cell.',
          data: 8,
        }
      ],
    },
    onFinish: function () {
      var $continueButton = $('#next_button');

      player.completeSectionTask();

      /*
      if (!$continueButton.is(':visible')) {
        $continueButton.show();
      }
      */
    },
  },
  '3': {
    activityType: DoubleMatchingActivity,
    dndPartContainerSelector: '#digfir_section_3 [data-block_type="dnd-part"]',
    dragItemsContainerSelector: '#digfir_section_3 .drag-items',
    dropAreasContainerSelector: '#digfir_section_3 .matching-drop-areas-container',
    triesCount: 1,
    dndSettings: {
      container: '#digfir_section_3 [data-type="rawhtml"] .match_test',
      bounds: '#digfir_section_3 [data-type="rawhtml"] .match_test',
      dragItems: [
        {
          node: '#second-matching-drag-item-1',
          data: 1,
          ariaLabel: 'postsynaptic membrane',
        },
        {
          node: '#second-matching-drag-item-2',
          data: 2,
          ariaLabel: 'transmitter-activated receptors',
        }
      ],
      dropAreas: [
        {
          node: '#second-matching-drop-area-1',
          ariaLabel: 'contains receptor molecules that receive chemical messages',
          data: 1,
        },
        {
          node: '#second-matching-drop-area-2',
          ariaLabel: 'site to which a neurotransmitter molecule binds',
          data: 2,
        }
      ],
    },
    onFinish: function () {

      player.completeSectionTask();

      /*
      var $continueButton = $('#next_button');

      if (!$continueButton.is(':visible')) {
        $continueButton.show();
      }
      */

      $('#digfir_section_3 [data-block_type="feedback"]').show().focus();
    },
  },
  '12': {
    activityType: OrderActivity,
    dndSettings: {
      container: '#digfir_section_12 .order_test',
      bounds: '#digfir_section_12 .order_test',
      alignRemainingDragItems: true,
      shiftDragItems: false,
      dragItems: [
        {
          node: '#order-item-1',
          data: 0,
          ariaLabel: 'Neurotransmitters are synthesized, packaged, and stored in vesicles in the presynaptic terminal.',
        },
        {
          node: '#order-item-2',
          data: 1,
          ariaLabel: 'An action potential arrives at the axon terminal, creating a change in voltage potential.',
        },
        {
          node: '#order-item-3',
          data: 2,
          ariaLabel: 'Voltage-activated calcium channels open on the presynaptic membrane.',
        },
        {
          node: '#order-item-4',
          data: 3,
          ariaLabel: 'Ca2+ ions flow into the presynaptic cell and bind to proteins, forming a complex that binds'
            + ' to vesicles.',
        },
        {
          node: '#order-item-5',
          data: 4,
          ariaLabel: 'Neurotransmitter-containing vesicles are transported to and bind to the presynaptic membrane.',
        },
        {
          node: '#order-item-6',
          data: 5,
          ariaLabel: 'Vesicles release their contents by exocytosis.',
        },
        {
          node: '#order-item-7',
          data: 6,
          ariaLabel: 'Neurotransmitters diffuse across the synaptic cleft.',
        },
        {
          node: '#order-item-8',
          data: 7,
          ariaLabel: 'Neurotransmitters bind to the appropriate receptors on the postsynaptic membrane, leading'
            + ' to several possible outcomes.',
        },
        {
          node: '#order-item-9',
          data: 8,
          ariaLabel: 'Neurotransmitters are released from the receptor sites.',
        },
        {
          node: '#order-item-10',
          data: 9,
          ariaLabel: 'Neurotransmitters are inactivated through either diffusion, degradation, reuptake,'
            + ' or astrocyte uptake.',
        }
      ]
    },
  }
};

var FiguresExtended = ProjectFigures.extend({
  media_finished_callback: function (mmid) {
    this._super();

    var active_section = window.player.sections[window.player.section_currently_showing];
    active_section.videos[mmid] = true;

    var cumulative_result = Object.values(active_section.videos).every(function (val) {
      return val;
    });

    if (cumulative_result) {
      window.player.completeSectionTask();
      $('[data-video-conditional="' + window.player.section_currently_showing + '"]').addClass('active_1');
    }
  }
});

var ChapterPlayer = ProjectPlayer.extend({

  slide13_answers_shown: false,

  customActivitiesSlides: {
    '2': null,
    '3': null,
    '12': null
  },

  initialize2: function () {
    this._super();

    /*
    this.customActivitiesSlides = {
      '2': null,
      '3': null,
      '12': null
    };
    */

     // add handler for infographic
     $('#digfir_section_3 [data-block_type="feedback"] [data-type="figure"] > img')
     .mouseup( function (e) {
      window.open(e.target.src);
    });
  },

  initialize_sections: function () {

    this._super();

    // brb: we can get rid of the below because we are using the new SAVI 
    // video player now

    /*
    var self = this;
    var i;
    var j;
    var $id;
    var $anim_btn;

    var video_list = [];
    for (var id in self.init_figures.bcVideo) {
      if (self.init_figures.bcVideo.hasOwnProperty(id)) {
        video_list.push(id);
      }
    }

    player.currentVideoID = '';
    player.videoIsPlaying = false;

    for (j = 0; j < this.sections.length; j++) {
      var s = this.sections[j];
      var $videos = s.jq.find('.outer_outer_outer_video');

      if ($videos.length) {
        s.videos = {};
        s.jq.find('[data-block_type="conditional_1"]').attr('data-video-conditional', j);
        $anim_btn = s.jq.find('.anim_ctrl_btn');
        if ($anim_btn.length) {
          s.animations = {};
          $anim_btn.each(function () {
            var $video = $($videos.get($(this).data('id'))).find('video');
            $id = $video.attr('id');
            s.animations[$id] = {
              animation: $video,
              parent: $video.parent().parent().parent().parent()
            };

            $(this).click({id: $id, sectionId: j}, function (ev) {
              var id = ev.data.id;
              var section = player.sections[ev.data.sectionId];
              if (!id || !section.animations[id]) {
                return;
              }

              if (id === player.currentVideoID) {
                if (player.videoIsPlaying) {
                  section.animations[player.currentVideoID].animation.get(0).pause();
                  player.videoIsPlaying = false;
                }
                else {
                  section.animations[player.currentVideoID].animation.get(0).play();
                  player.videoIsPlaying = true;
                }
              }
              else {
                for (var key in section.animations) {
                  if (section.animations.hasOwnProperty(key)) {
                    var $animation = section.animations[key].animation;
                    // var $parent = section.animations[key].parent;
                    var animation = $animation.get(0);

                    // $animation.attr('aria-hidden', 'true').addClass('hidden');
                    //$parent.hide();
                    animation.pause();
                    animation.currentTime = 0;
                  }
                }

                section.animations[id].animation.get(0).play();
                section.animations[id].parent.show();
                player.currentVideoID = id;
                player.videoIsPlaying = true;
              }
            });
          });
        }

        $videos.each(function () {
          var $id = $(this).find('video').attr('id');

          for (i = 0; i < video_list.length; i++) {
            if ($id.indexOf(video_list[i]) > -1) {
              s.videos[video_list[i]] = false;
              // if ($anim_btn.length) {
              //  $id =
              //  s.animations[]
              }
              break;
            }
          }
        });
      }
    } // end for
    */

  },

  show_section: function ( section_to_show ) {
    this._super(section_to_show);

    safe_log('show_section(' + section_to_show + ')');

    this.checkActivitiesExist(CUSTOM_ACITIVITIES_PARAMS, this.customActivitiesSlides);

    // always show Next button on slide 13 if the user has made it to 
    // slide 14 previously
    /*
    if (this.ARGA_running && this.section_currently_showing == 12) {
      var las = this.get_LASX();
      if (las > 12) {
        $('#next_button').show();
      }
    }
    */

   var lasx = player.ARGA_running ? this.get_LASX() : this.last_available_section;
  
  if (this.section_currently_showing === 2) {
    if (lasx > 2) {
      try {
        this.customActivitiesSlides['2'].showAnswers();
        $('#digfir_section_2').find('button.match-button').remove();
      }
      catch(e) { safe_log(e.message); }
    }
  }
  if (this.section_currently_showing === 3) {
    if (lasx > 3) {
      try {
        this.customActivitiesSlides['3'].showAnswers();
        $('#digfir_section_3').find('button.match-button').remove();
        // feedback
        $('#idm10512').show();
      }
      catch(e) { safe_log(e.message); }
    }
  }
  if (this.section_currently_showing === 12) {
    if (lasx > 12) {
      try {
        this.customActivitiesSlides['12'].showAnswers();
        $('#digfir_section_12').find('button.match-button').remove();
        // Check My Work button
        $('#digfir_section_12').find('button.check-btn').remove();
      }
      catch(e) { safe_log(e.message); }
    }
  }


    // if LASX > current section always show Next button
    if (lasx > this.section_currently_showing) {
     $('#next_button').show(); 
    }

    if (this.section_currently_showing === (this.sections.length - 1)) {
      $('#next_button').hide();
    }

  }



});

Figures = FiguresExtended;
window.player = new ChapterPlayer();


/***/ }),

/***/ 38:
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),

/***/ 58:
/***/ (function(module, exports, __webpack_require__) {

var ReusableMatchingActivity = __webpack_require__(26);
var platform = __webpack_require__(0).run_on;

var DEFAULT_PARAMS = {
  commonDragItemsSettings: {
    selectedItemClassName: 'selected-item',
    initialAriaKeyboardDesc: 'Press Spacebar or use double Tap to select this element to corresponding position.',
    imgSelector: '.image-container'
  },
  commonDropAreasSettings: {
    initialAriaKeyboardDesc: 'Use arrow keys or swipe gestures to navigate between labels. Press spacebar or use Double'
      + ' Tap to confirm matching.',
  },
  a11yTexts: {
    correct: 'All answers are correct',
    someIncorrect: 'Some of your answers are incorrect.',
    incorrect: 'All answers are incorrect.',
    resetButton: 'Activity has been reset.',
    showAnswersButton: 'The correct answers are shown.',
    onEmptyDragAttempt: 'Selection is not possible. First select the element to drag.',
  }
};

var SAY_VIA_ARIA_LABEL = platform.ios || platform.android || platform.mac || platform.ie;

/* eslint-disable prefer-rest-params */
var DoubleMatchingActivity = function (params) {
  this.$container = $(params.dndSettings.container);

  params.dndSettings.dragItems = this.randomizeItems(params.dndSettings.dragItems, this.$container.find('.drag-items'));
  params.dndSettings.dropAreas =
    this.randomizeItems(params.dndSettings.dropAreas, this.$container.find('.matching-drop-areas-container'));

  ReusableMatchingActivity.apply(this, arguments);

  this.$dragItemsContainer = $(this.params.dragItemsContainerSelector);
  this.$dropAreasContainer = $(this.params.dropAreasContainerSelector);
  this.triesCount = 0;
};

DoubleMatchingActivity.prototype = Object.create(ReusableMatchingActivity.prototype);

DoubleMatchingActivity.prototype.getParams = function (params) {
  var activityParams = ReusableMatchingActivity.prototype.getParams.apply(this, arguments);

  return $.extend(true, {}, activityParams, DEFAULT_PARAMS, params);
};

DoubleMatchingActivity.prototype.createButtons = function () {
  this.$buttonsContainer = $('<div class="matching-buttons-container"></div>');
  this.$checkButton = this.createButton('Check Your Answers', 'match-button control_button', this.checkAnswers);

  this.$buttonsContainer.append(this.$checkButton);

  this.$checkButton.attr('disabled', true);

  $(this.dnd.container.parentNode).after(this.$buttonsContainer);
};

DoubleMatchingActivity.prototype.checkAnswers = function (e) {

  this.dnd.dragItems.forEach(this.setItemStatus.bind(this));
  $('.feedback').remove();

  this.addNavigationAccess();

  this.triesCount++;

  if (this.triesCount === this.params.triesCount && !this.isActivityFinished()) {
    // Screenreader doesn't say new button name, so we place its name to aria-live
    this.say(this.getFeedbackMessage() + ' Show correct answers. button');

    this.dnd.disable();
  }
  else
  if (this.triesCount !== this.params.triesCount
      && !this.isActivityFinished()
      && this.params.triesCount !== 1) {
      this.$checkButton.html('Try again');

      if (this.triesCount === 3) {
        this.dnd.disable();
        this.$checkButton.html('Show correct answers');
      }
      else {
        var count = 3 - this.triesCount;
        this.say(this.getFeedbackMessage() + 'You have ' + count + ' attempts left.');
        $('.matching-buttons-container')
          .after('<p class="feedback">'+ this.getFeedbackMessage()
          +'You have ' + count + ' attempts left.'+'</p>');
        $('.feedback').focus();
        this.disableButton(this.$checkButton);
      }
  }

  if (this.triesCount === this.params.triesCount || this.isActivityFinished()) {
    this.showAnswers();
    this.say(this.getFeedbackMessage());
    $('.cg-dnd-visually-hidden').remove();
    this.params.onFinish();
  }
};

DoubleMatchingActivity.prototype.setItemStatus = function (item) {
  if (item.correct) {
    item.chosenDropArea.showStatusIcon(true);
    this.paintElements(item, item.chosenDropArea, this.params.correctColor);
    item.disable();
  }
  else {
    item.reset();
    this.drawLinkTo(item, item.coordinates.currentStart);
  }
};

DoubleMatchingActivity.prototype.showDndPart = function () {
  this.dnd.dragItems.forEach(this.hideDragCircles);
  this.dnd.dropAreas.forEach(this.hideDropCircles);
  this.$showDndButton.attr('disabled', true);
};

DoubleMatchingActivity.prototype.setWrong = function (item, area, afterTimeOutCB) {
  var focusedLiveText = this.say(this.params.a11yTexts.incorrect, '', SAY_VIA_ARIA_LABEL);

  setTimeout(function () {
    item.reset();
    item.focus(focusedLiveText);

    afterTimeOutCB && afterTimeOutCB();
  }, this.params.wrongPositionTimeout);
};

DoubleMatchingActivity.prototype.hideDragCircles = function (elem) {
  elem.node.parentNode.style.display = 'none';

  if (elem.link) {
    elem.link.hide();
  }
};

DoubleMatchingActivity.prototype.hideDropCircles = function (elem) {
  var iconNode = elem.node.nextSibling;

  elem.node.style.display = 'none';
  iconNode.style.display = 'none';
};

DoubleMatchingActivity.prototype.showAnswers = function () {
  ReusableMatchingActivity.prototype.showAnswers.apply(this, arguments);
};

DoubleMatchingActivity.prototype.randomizeItems = function (settings, $container) {
  var randomizedItemsSettings = [];

  settings.forEach(function (itemSettings) {
    var $itemRow = $(itemSettings.node).closest('.row');

    if (this.getRandomInt(0, 2)) {
      $container.append($itemRow);
      randomizedItemsSettings.push(itemSettings);
    }
    else {
      $container.prepend($itemRow);
      randomizedItemsSettings.unshift(itemSettings);
    }
  }.bind(this));

  return randomizedItemsSettings;
};

DoubleMatchingActivity.prototype.getRandomInt = function (min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);

  return Math.floor(Math.random() * (max - min)) + min;
};


module.exports = DoubleMatchingActivity;


/***/ }),

/***/ 60:
/***/ (function(module, exports, __webpack_require__) {

var CgDnd = __webpack_require__(6);

var DEFAULT_PARAMS = {
  correctColor: '#17891A',
  incorrectColor: '#B00000',
  correctClassName: 'correct',
  maxTries: 3,
  a11yTexts: {
    selected: 'Element grabbed, ',
    selectedKeyboardInstruction: 'Use Arrow Key or swipe gesture to navigate between positions.',
    finishDrag: 'Element dropped, ',
    correct: 'All answers are correct',
    incorrect: 'Some of your answers are incorrect.',
  },
  dndSettings: {
    bounds: document.documentElement,
    container: document.documentElement,
    alignRemainingDragItems: true,
    liveTextElement: '#live-feedback',
    selectedDragItemClassName: 'selected-item',
    commonDragItemsSettings: {
      className: 'custom-class',
      selectedItemClassName: 'selected-item',
      initialAriaKeyboardDesc: 'Press Spacebar use Double Tap to select this element, use arrow keys'
        + ' or Swipe gesture to move selected elements.',
      initialAriaElementDesc: '',
    }
  },
  onFinish: function () {

    player.completeSectionTask();

    var $continueButton = $('#next_button');

    /*
    if (!$continueButton.is(':visible')) {
      $continueButton.show();
    }
    */

    $continueButton.focus();
  },
  onInit: function () {
    var $continueButton = $('#next_button');

    $continueButton && $continueButton.hide();
  }
};

var OrderActivity = function (params) {
  this.params = this.getParams(params);
  this.setItemsNodes();

  this.triesCount = 0;
  this.correctItemsCount = 0;
  this.$container = $(this.params.dndSettings.container);

  this.randomizeItems();
  this.alignItemsHeight(this.params.dndSettings.dragItems);

  this.dnd = new CgDnd(this.getDnDParams(this.params.dndSettings));
  this.itemsCurrentOrder = [];

  this.createButtons();

  this.$liveFeedback = $('#live-feedback');

  this.params.onInit();
};

OrderActivity.prototype.getParams = function (params) {
  return $.extend(true, {}, DEFAULT_PARAMS, params);
};

OrderActivity.prototype.getDnDParams = function (params) {
  return $.extend(
    true,
    {},
    DEFAULT_PARAMS.dndSettings,
    {
      onDragStop: this.onDragStop.bind(this),
      onDragItemSelect: this.onDragItemSelect.bind(this),
    },
    params
  );
};

OrderActivity.prototype.createButtons = function () {
  var $buttonsContainer = $('<div class="order-buttons-container"></div>');

  this.$checkButton = this.createButton('Check My Work', 'check-btn control_button', this.checkOrder.bind(this));
  // this.$resetButton = this.createButton('Try Again', 'control_button', this.reset.bind(this)).attr('disabled', true);
  this.$showAnswersButton = this.createButton('Show Answers', 'control_button', this.showAnswers.bind(this)).hide();

  this.$container.after($buttonsContainer);

  $buttonsContainer.append(this.$showAnswersButton, this.$checkButton);
};

OrderActivity.prototype.createButton = function (btnText, classNames, onClick) {
  var $button = $('<button class="' + classNames + '">' + btnText + '</button>');

  $button.bind('click', onClick.bind(this));

  return $button;
};

OrderActivity.prototype.checkOrder = function () {
  this.dnd.dragItems.forEach(this.checkItem.bind(this));
  $('.feedback').remove();

  this.triesCount++;

  var areAttemptsEnded = this.triesCount === this.params.maxTries;

  if (this.isAllCorrect()) {
    this.say(this.params.a11yTexts.correct);
    this.finishActivity();
  }
  else {
    var count = 3 - this.triesCount;
    if (count !== 0) {
      $('.order-buttons-container')
      .after('<p class="feedback">'+ this.params.a11yTexts.incorrect + ' You have '
      + count + ' attempts left.'+'</p>');
      $('.feedback').focus();
    }
  }

  if (areAttemptsEnded) {
    this.finishActivity();

    this.$showAnswersButton.show();
  }
};

OrderActivity.prototype.reset = function () {
  this.dnd.reset();
};

OrderActivity.prototype.showAnswers = function () {

  if (player.slide13_answers_shown) {
    return;
  }

  this.itemsCurrentOrder = this.dnd.dragItems.slice().sort(function (item1, item2) {
    return item1.coordinates.current.top - item2.coordinates.current.top;
  });

  this.dnd.remainingDragItems.forEach(function (item) {
    item.translateTo(this.itemsCurrentOrder[item.data].coordinates.current.update(), true);
    item.disable();
    this.setCorrect(item, true);
  }.bind(this));

  player.slide13_answers_shown = true;

};

OrderActivity.prototype.findFirstRemainingItem = function () {
  var currentFirstItem = this.dnd.dragItems.reduce(function (result, item) {
    item.tabIndex = -1;

    if (item.index < result.index) {
      result = item;
    }

    return result;
  }, {index: 9999});

  currentFirstItem.tabIndex = 0;
};

OrderActivity.prototype.finishActivity = function () {
  this.$checkButton.attr('disabled', true);

  this.dnd.dragItems.forEach(function (item) {
    if (!item.disabled) {
      item.disable();
      item.addClass('disabled');
      item.ariaHidden = false;
    }
  });

  this.params.onFinish();
  this.$container.removeAttr('role');
  this.findFirstRemainingItem();
};

OrderActivity.prototype.checkItem = function (item) {
  if (item.index === item.data && !item.correct) {
    this.setCorrect(item);
  }
};

OrderActivity.prototype.setCorrect = function (item, isFinished) {
  item.correct = true;
  item.ariaLabel = 'Correct. ' + item.ariaLabel;
  item.addClass(this.params.correctClassName);
  item.disable();
  item.ariaHidden = false;

  if (!isFinished) {
    this.dnd.remainingDragItems.splice(this.dnd.remainingDragItems.indexOf(item), 1);
  }

  this.correctItemsCount++;
};

OrderActivity.prototype.isAllCorrect = function () {
  return this.correctItemsCount === this.dnd.dragItems.length;
};

OrderActivity.prototype.say = function (text, mode, sayViaAriaLabel) {
  var liveMode = mode || 'polite';

  if (this.$liveFeedback.attr('aria-live') !== liveMode) {
    this.$liveFeedback.attr('aria-live', liveMode);
  }

  if (sayViaAriaLabel) {
    return {liveText: text};
  }
  else {
    this.$liveFeedback.html(text);
  }
};

OrderActivity.prototype.getPositionMsgPart = function (item) {
  return 'position ' + (item.index + 1) + ' of ' + this.dnd.dragItems.length + '.';
};

OrderActivity.prototype.onDragItemSelect = function (e, params) {
  if (params.chosenDraggedItem && params.dragItem !== params.chosenDraggedItem) {
    this.dnd.shuffleDragItems(params.chosenDraggedItem, params.dragItem, function (item1, item2) {
      item1.focus();
    });

    this.say(this.params.a11yTexts.finishDrag + 'final ' + this.getPositionMsgPart(params.chosenDraggedItem));
  }
  else {
    this.say(this.params.a11yTexts.selected + 'current ' + this.getPositionMsgPart(params.dragItem)
      + ' ' + this.params.a11yTexts.selectedKeyboardInstruction);
  }
};

OrderActivity.prototype.onDragStop = function (e, params) {
  if (params.dragItem1 && params.dragItem2) {
    this.replaceItemsDescriptions(params.dragItem1, params.dragItem2);
  }
};

OrderActivity.prototype.replaceItemsDescriptions = function (item1, item2) {
  var item1CurrentDesc = item1.currentAriaState;
  var item2CurrentDesc = item2.currentAriaState;

  item1.changeCurrentAriaState(function () {
    return item2CurrentDesc;
  });
  item2.changeCurrentAriaState(function () {
    return item1CurrentDesc;
  });
};

OrderActivity.prototype.randomizeItems = function () {
  var randomizedItemsSettings = [];

  this.params.dndSettings.dragItems.forEach(function (itemSettings) {
    if (this.getRandomInt(0, 2)) {
      this.$container.append($(itemSettings.node));
      randomizedItemsSettings.push(itemSettings);
    }
    else {
      this.$container.prepend($(itemSettings.node));
      randomizedItemsSettings.unshift(itemSettings);
    }
  }.bind(this));

  randomizedItemsSettings.forEach(function (itemSettings, index) {
    itemSettings.initialAriaElementDesc = 'Position ' + (index + 1) + ' of ' + randomizedItemsSettings.length + '. ';
  });

  this.params.dndSettings.dragItems = randomizedItemsSettings;
};

OrderActivity.prototype.getRandomInt = function (min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);

  return Math.floor(Math.random() * (max - min)) + min;
};

OrderActivity.prototype.setItemsNodes = function () {
  this.params.dndSettings.dragItems.forEach(function (item) {
    item.node = document.querySelector(item.node);
  });
};

OrderActivity.prototype.getItemMaxHeight = function (items) {
  return items.reduce(function (maxHeight, item) {
    var itemHeight = item.node.getBoundingClientRect().height;

    return itemHeight > maxHeight ? itemHeight : maxHeight;
  }, 0);
};

OrderActivity.prototype.alignItemsHeight = function (items) {
  var maxHeight = this.getItemMaxHeight(items);

  items.forEach(function (item) {
    item.node.style.height = maxHeight + 'px';
  });
};

module.exports = OrderActivity;


/***/ }),

/***/ 78:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(29);


/***/ })

},[78]);
//# sourceMappingURL=kolb_nia_winter2019_ch05_1.js.map