webpackJsonp([1],{

/***/ 31:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(40);
__webpack_require__(54);

var common = __webpack_require__(1);
var dom = __webpack_require__( 2 );
var platform = __webpack_require__(0).run_on;

var ProjectPlayer = __webpack_require__(3);
var ProjectMCQuery = __webpack_require__(5);
var ProjectActivity = __webpack_require__(7);
var svg = __webpack_require__(53);
var show_next_question = ProjectActivity.prototype.show_next_question;

var ASTERISK = '<rect class="ast_back" x="0" y="0" width="8" height="8" rx="2" ry="2"/>' +
  // '<path class="ast_line" d="M4 0.5 L 4 7.5"/>' +
  '<path class="ast_line" d="M2 1 L 6 7"/>' +
  '<path class="ast_line" d="M2 7 L 6 1"/>';
var CHECKMARK = '<rect class="ast_back" x="0" y="0" width="8" height="8" rx="2" ry="2"/>' +
  '<path class="chk_line" d="M 0.5,3.5 L 3,6 L 7,1"/>';

/*
var ChapterActivity = Activity.extend({
  question_submit_button_label: 'Check Your Answer',
  question_submit_button: function (q) {
    var classList = 'standard_button question_submit_button';
    var btnLabel = player.activity.question_submit_button_label;
    if (q.queries[0].is_hs_type) {
      classList += ' hs_submit_hidden';
      btnLabel += 's';
    }

    // define question_submit_button_label as a variable so it can be overridden
    return '<input class=\'' + classList +
      '\' type=\'button\' id=\'question_submit_button_' + q.index + '\' value=\'' + btnLabel + '\' />';
  }
});*/

ProjectActivity.prototype.show_next_question = function (question) {
  show_next_question.call(this, question);

  if ( question.question_sequence != null ) {
    var qs = question.question_sequence;
    var next_qs_index = question.question_sequence_index + 1;
    var next_question = qs.questions[next_qs_index];

    if (qs.one_at_a_time === true && next_question == null && qs.sequence_complete === 'partial') {
      $('.question_sequence_review_button').remove();
      qs.sequence_complete = 'complete';
    }
  }
};

var ChapterPlayer = ProjectPlayer.extend({

  screen7_widget_1_completed: false,
  screen7_widget_2_completed: false,

  /* initialize: function (isWithoutAccessibleTables) {
    this._super(isWithoutAccessibleTables);
    this.activity = new ChapterActivity();
  }, */
  initialize_sections: function () {
    this._super();
    var i;
    var j;
    var jj;

    this.animations = {};
    for (j = 0; j < this.sections.length; j++) {
      var s = this.sections[j];

      var $transient_btn = s.jq.find('.tr_btn');
      $transient_btn.each(function (index) {
        var $el = $(this);
        var $id = $el.data('id');
        var $container = s.jq.find('[data-block_type="' + $id + '"]');
        var $video = $container.find('video');
        $container.find('.vjs-poster').hide();
        $container.find('.vjs-custom-endscreen-overlay').hide();
        $video.attr('data-id', $id);
        var $parent = $video.parent().parent().parent().parent();
        if (index > 0) {
          $video.attr('aria-hidden', 'true').addClass('hidden');
          $parent.hide();
        }

        player.animations[$id] = {
          control: $el,
          animation: $video,
          parent: $parent
        };
        $video.onended = player.onAnimationEnded.bind(player);

        $el.click(function () {
          $('.transcript_btn').attr('href', 'asset/transcripts/' + $id + '.html')
            .attr('aria-label', $el.attr('aria-label') + ' transcript');
          player.playAnimation.call(player, $id);
        });
      });

      player.currentVideoID = '';
      player.videoIsPlaying = false;

      s.jq.find('.transcript_btn').click(function () {
        player.videoIsPlaying = false;
      });

      var $hsContainer = this.sections[j].jq.find('[data-block_type="hs_hoverable"]');
      var $hsMeta = $hsContainer.find('[data-type="metadata"] [data-type="field"][key="hs_regions"]');
      if ($hsMeta.length) {
        var hsOpts = JSON.parse($hsMeta.text());
        $hsContainer.html(getHTML(hsOpts, true));
      }

      var $hs_aria = s.jq.find('.question_sequence_closing_material [data-type="metadata"] [key="hs_aria"]');
      if ($hs_aria.length) {
        var hs_aria = JSON.parse($hs_aria.text());
        var ida;
        for (i = 0; i < hs_aria.query_hs.length; i++) {
          for (jj = 0; jj < hs_aria.query_hs[i].length; jj++) {
            ida = ('ids' in hs_aria ? hs_aria.ids[i] : 'aria_reg') + jj;
            s.jq.append('<div class="visually-hidden" id="' + ida + '">' + hs_aria.query_hs[i][jj] + '</div>');
          }
        }
        $hs_aria.remove();
        s.jq.closest('[data-type="box"]')
          .find('.question_sequence_closing_material [data-type="metadata"] [key="source_images"]').remove();
        s.jq.closest('[data-type="box"]')
          .find('.question_sequence_closing_material [data-type="metadata"] [key="hs_choices"]').remove();
      }
    }
  },
  initialize2: function () {
    this._super();
    $('#question_submit_button_1').attr('value', 'Check Your Answers');
    $('#digfir_section_7 .question_sequence_navigator').remove();
//  $('#question_submit_button_2').attr('value', 'Check Your Answers');
    var $hsItems = $('.hs_item');
    if ($hsItems.length) {
      var hideAllHS = function (event) {
        event.currentTarget.parentNode.childNodes.forEach(function (el) {
          el.setAttribute('class', 'hs_item');
          el.setAttribute('aria-pressed', 'false');
          (function () {
            var cid = el.getAttribute('data-controlled_id');
            if (cid) {
              var $el = $('#' + cid);
              $el.addClass('item_hidden');
            }
          })();
        });
      };
      var toggleTargetHS = function (event) {
        event.currentTarget.setAttribute('class', 'hs_item active');
        event.currentTarget.setAttribute('aria-pressed', 'true');
        (function () {
          var cid = event.currentTarget.getAttribute('data-controlled_id');
          if (cid) {
            var $el = $('#' + cid);
            $el.removeClass('item_hidden');
            setTimeout(function () {
              player.updateLiveRegion($el.text());
            }, 500);
          }
        })();
      };
      var actionHandler = function (event) {
        if (event.currentTarget.getAttribute('aria-pressed') == 'true') {
          hideAllHS(event);
        }
        else {
          hideAllHS(event);
          toggleTargetHS(event);
        }
      };
/*
      $hsItems.live('focus', function (event) {
        hideAllHS(event);
        toggleTargetHS(event);
      });
      $hsItems.live('blur', function (event) {
        hideAllHS(event);
      });
*/
      /* $hsItems.live('mouseenter', function (event) {
        event.preventDefault();
        hideAllHS(event);
        toggleTargetHS(event);
      }).live('mouseleave', function (event) {
        event.preventDefault();
        hideAllHS(event);
      }); */
      $hsItems.live('click', function (event) {
        event.preventDefault();
        actionHandler(event);
      }).each(function () {
        var cId = this.getAttribute('data-controlled_id');
        var $c = $(this).closest('.hs_container');
        $c.append($('#' + cId));
      }).live('keydown', function (event) {
        var isSpace = event.key === ' ' || event.key === 'Spacebar' || event.keyCode == 32;
        var isEnter = event.key === 'Enter' || event.keyCode === 13;

        if (isSpace || isEnter) {
          event.preventDefault();
          actionHandler(event);
        }
      });
    }
    $('#screen7_widget_1').append(dom.createHTML(svg));
    init('#screen7_widget_1',
    [
      '',
      'Massaging the area increases the firing rate of the <span data-type="termref" data-term="haptic">haptic</span> '+
      '(touch and pressure) receptors in that area.',
      'This increased response will produce <span data-type="termref" data-term="excitatory">excitatory</span> ' +
      'postsynaptic potentials in the <span data-type="termref" data-term="interneuron">interneuron</span> in the ' +
      'spinal cord, increasing the response rate of the interneuron.',
      'When the interneuron increases its response rate, there will be an increase in <span data-type="termref" ' +
      'data-term="inhibitory">inhibitory</span> postsynaptic ' +
      'potentials in the <span data-type="termref" data-term="nociceptive">nociceptive</span> spinal neuron. ' +
      'Therefore, the firing rate in the nociceptive spinal neuron will decrease, and fewer <span data-type="termref" '+
      'data-term="action potential">action potentials</span> will reach the <span data-type="termref" ' +
      'data-term="primary somatosensory cortex">somatosensory cortex</span>, reducing the perception of pain.'
    ],
      [
        {
          point_speed: 2,
          line_speed: 12
        },
        {
          point_speed: 4,
          line_speed: 6
        },
        {
          point_speed: 4,
          line_speed: 6
        },
        {
          point_speed: 1,
          line_speed: 24
        }
    ]
    );
    $('#screen7_widget_2').append(dom.createHTML(svg));
    init('#screen7_widget_2',
      [
      '',
      'Decreasing the response rate from the <span data-type="termref" data-term="haptic">haptic</span> (touch and ' +
      'pressure) somatosensory receptors could occur if you experience a massage that decreases in intensity or ends. '+
      'The end (or reduced intensity) of the haptic somatosensory experience will decrease the response rate of the ' +
      'haptic receptors and remove the <span data-type="termref" data-term="excitatory">excitatory</span> input to ' +
      'the spinal <span data-type="termref" data-term="interneuron">interneuron</span>.',
      'This will, in turn, decrease the response rate of the interneuron, which will decrease the number of ' +
      '<span data-type="termref" data-term="inhibitory">inhibitory</span> postsynaptic potentials generated from the ' +
      'interneuron-spinal <span data-type="termref" data-term="nociceptive">nociceptive</span> synapse.',
      'This will end up increasing the response rate of the nociceptive spinal neuron and increase the perception ' +
      'of pain.'
    ],
      [
        {
          point_speed: 2,
          line_speed: 12
        },
        {
          point_speed: 1,
          line_speed: 24
        },
        {
          point_speed: 1,
          line_speed: 24
        },
        {
          point_speed: 4,
          line_speed: 6
        }
    ]);
  },

  onAnimationEnded: function () {
    player.videoIsPlaying = false;
  },

  playAnimation: function (id) {
    if (!id || !this.animations[id]) {
      return;
    }

    if (id === this.currentVideoID) {
      if (this.videoIsPlaying) {
        this.animations[this.currentVideoID].animation.get(0).pause();
        this.videoIsPlaying = false;
      }
      else {
        this.animations[this.currentVideoID].animation.get(0).play();
        this.videoIsPlaying = true;
      }
    }
    else {
      for (var key in this.animations) {
        if (this.animations.hasOwnProperty(key)) {
          var $animation = this.animations[key].animation;
          var $parent = this.animations[key].parent;
          var animation = $animation.get(0);

          $animation.attr('aria-hidden', 'true').addClass('hidden');
          $parent.hide();
          animation.pause();
          animation.currentTime = 0;
        }
      }

      this.animations[id].animation.removeAttr('aria-hidden').removeClass('hidden').get(0).play();
      this.animations[id].parent.show();
      this.currentVideoID = id;
      this.videoIsPlaying = true;
    }
  },

  show_section: function (section_to_show) {
    //console.log(section_to_show + '---' + this.section_currently_showing + '----' + this.last_available_section);
    // brb: Not sure  why this was necessary but it is causing problems
    // after the activity has been completed if the student goes back to 
    // section 2 before exiting.
    /*
    if (this.section_currently_showing === 2) {
      this.last_available_section = this.section_currently_showing + 1;
    }
    */
    this._super(section_to_show);
  }
});

var ProjectHSQuery = ProjectMCQuery.extend( {
  parseSource: function () {
    // eslint-disable-next-line
    this._super.apply(this, arguments);

    var img_layer_src;
    var hs_config;
    var hs_aria;

    var $source_img = this.jq.closest('[data-type="box"]')
      .find('.question_sequence_closing_material [data-type="metadata"] [key="source_images"]');
    var $hs_choices = this.jq.closest('[data-type="box"]')
      .find('.question_sequence_closing_material [data-type="metadata"] [key="hs_choices"]');
    var $hs_aria = this.jq.closest('[data-type="box"]')
      .find('.question_sequence_closing_material [data-type="metadata"] [key="hs_aria"]');

    if ($source_img.length === 1 && $hs_choices.length === 1 && $hs_aria.length === 1) {
      img_layer_src = JSON.parse($source_img.text());
      hs_config = JSON.parse($hs_choices.text());
      hs_aria = JSON.parse($hs_aria.text());
    }
    else if ('hs_choices' in this.md && 'source_images' in this.md && 'hs_aria' in this.md) {
      img_layer_src = JSON.parse(this.md['source_images']);
      hs_config = JSON.parse(this.md['hs_choices']);
      hs_aria = JSON.parse(this.md['hs_aria']);
    }

    this.is_hs_type = (typeof img_layer_src !== 'undefined');
    this.correct_coefficient = '_ans_cf' in this.md ? this.md['_ans_cf'] : '1';

    if (this.is_hs_type) {
      var old_alts = [];
      var graph_choices = [''];
      var correct_choice = this.choices[this.correct_answer_index];

      for (var i = 0; i < img_layer_src.length; i++) {
        old_alts = graph_choices.slice(0);
        graph_choices = [];
        for (var j = 0; j < hs_config[i].length; j++) {
          for (var k = 0; k < old_alts.length; k++) {
            graph_choices.push(old_alts[k] + j);
          }
        }
      }

      this.choices = graph_choices;
      this.correct_answer_index = this.choices.indexOf(correct_choice);
      this.img_layer_src = img_layer_src;
      this.hs_config = hs_config;
      this.hs_aria = hs_aria;
    }
  },
  postInit: function () {
    var self = this;
    var $hsLink = $('[data-query_index="' + self.query_index + '"] .hs_link');
    var checkHs = function (event, img_layer_src, query_index) {

      safe_log('checkHs()');

      // var curEls = event.currentTarget.parentNode.childNodes;
      // var i;
      // var classList = [];
      // var j;
      // for (i = 0; i < curEls.length; i++) {
      //   classList = curEls[i].getAttribute('class').split(/\s+/);
      //   j = classList.indexOf('active');
      //   if (j >= 0) {
      //     classList.splice(j, 1);
      //   }
      //   curEls[i].setAttribute('class', classList.join(' '));
      //   curEls[i].setAttribute('aria-checked', 'false');
      // }
      if (event.currentTarget.getAttribute('aria-checked') == 'true') {
        // event.currentTarget.classList.remove('active');
        event.currentTarget.setAttribute('aria-checked', 'false');
      }
      else {
        // event.currentTarget.classList.add('active');
        event.currentTarget.setAttribute('aria-checked', 'true');
      }

      var checked_hs_count = $(event.currentTarget).parents('.hs_query').find('[aria-checked=true]').length;
      var $submitButton = $('#question_submit_button_' + (query_index + 1));
      if (checked_hs_count === img_layer_src.length) {
        $submitButton.removeClass('hs_submit_hidden');
      }
      else {
        $submitButton.addClass('hs_submit_hidden');
      }
    };

    $hsLink.live('keydown', function (event) {
      var isSpace = event.key === ' ' || event.key === 'Spacebar' || event.keyCode == 32;
      var isEnter = event.key === 'Enter' || event.keyCode === 13;

      if (isSpace || isEnter) {
        event.preventDefault();
        var is_answered = self.user_answer_index !== null;

        if (!is_answered) {
          checkHs(event, self.img_layer_src, self.query_index);
        }
      }
    }).live('click', function (event) {
      event.preventDefault();
      var has_touch = 'ontouchstart' in window;
      if (has_touch) return false;

      var is_answered = self.user_answer_index !== null;
      if (!is_answered) {
        checkHs(event, self.img_layer_src, self.query_index);
      }
    }).live('touchstart', function (event) {
      event.preventDefault();
      var has_touch = 'ontouchstart' in window;
      if (!has_touch) return false;

      var is_answered = self.user_answer_index !== null;
      if (!is_answered) {
        checkHs(event, self.img_layer_src, self.query_index);
      }
    });
  },
  getHTML: function (mode) {
    if (this.is_hs_type) {
      var html = '';
      var disabled = '';
      var is_answered = (this.user_answer_index !== null);
      var answered_class = (is_answered) ? 'inactive' : '';
      var queryHtml = this.query_text_html();
      var $query = $(queryHtml);
      var counter = $('.question_sequence_navigator').text().trim();


      safe_log('getHTML: is_answered = ' + is_answered);
      safe_log(this);

      queryHtml = $query.html();
      if (mode === 'review' || mode === 'review_correct_incorrect' || mode === 'preview') {
        // The input should be disabled, unless we're in review_correct_incorrect mode
        disabled = (mode !== 'review_correct_incorrect') ? 'aria-disabled="true" tabindex="-1"' : 'tabindex="0"';
        queryHtml = '<span class="visually-hidden">' + counter + '</span>' + queryHtml;
      }

      html += '<div class="hs_query" data-query_index="' + this.query_index + '">';
      html += '<div class="query_text" id="question' + this.query_index + '">' + queryHtml + '</div>';

      for (var i = 0;
           i < this.img_layer_src.length;
           i++) {
        html += '<fieldset ' +
                  'class="mc_query_group">' +
                  'regions' in this.hs_aria ? '<legend>' + this.hs_aria.regions[i] + '</legend>' : '';
        html += '<svg ' +
                  'version="1.1" ' +
                  'xmlns="http://www.w3.org/2000/svg" ' +
                  'xmlns:xlink="http://www.w3.org/1999/xlink" ' +
                  'preserveAspectRatio="xMidYMid meet" ' +
                  'data-field_index="' + i + '" ' +
                  'x="0px" y="0px" ' +
                  'viewBox="0 0 ' + this.img_layer_src[i].width + ' ' + this.img_layer_src[i].height + '" ' +
                  'xml:space="preserve" ' +
                  'tabindex="-1" ' +
                  'focusable="false" ' +
                  'role="radiogroup">';
        html += '<image ' +
                  'overflow="visible" ' +
                  'x="0" y="0" ' +
                  'width="' + this.img_layer_src[i].width + '" ' +
                  'height="' + this.img_layer_src[i].height + '" ' +
                  'xlink:href="' + this.img_layer_src[i].src + '" ' +
                  'tabindex="-1" ' +
                  'focusable="false" ' +
                  'aria-label="Scheme of the spinothalamic tract."> ' +
                '</image>';
        html += '<g ' +
                  'data-hs_group="' + i + '" ' +
                  'class="' + answered_class + '">';

        for (var j = 0,
                 translate_x,
                 translate_y,
                 is_correct_answer,
                 is_user_answer,
                 hs_config;
             j < this.hs_config[i].length;
             j++) {
          hs_config = this.hs_config[i][j];
          translate_x = hs_config.asterisk[0];
          translate_y = hs_config.asterisk[1];
          is_correct_answer = (1<<j) & this.md.ans_cf;
          is_user_answer = (1<<j) & this.user_answer;
          html += '<a ' +
                    'class="hs_link' + (is_answered && (is_correct_answer) ? ' active' : '') + '" ' +
                    'xlink:href="#"' + ' ' +
                    'data-field_index="' + i + '" ' +
                    'data-hs_index="' + (1<<j) + '" ' +
'aria-describedby="' +
            ((j == 0) ? 'question' + this.query_index + ' ' : '')
            +('ids' in this.hs_aria ? this.hs_aria.ids[i] : 'aria_reg') +
            j + '" ' +
'aria-label="area ' + (j + 1) + (is_answered ? ((is_correct_answer) ? ' (correct)' : ' (incorrect)') : '') + '" ' +
                    'role="checkbox" ' +
                    'tabindex="0"' +
                    'aria-checked="false" ' + disabled + ' ' +
                    'style="fill-opacity: 1; stroke-width: 1;color:' + hs_config.fill + ';"' +
                  '>';
          html += ('path' in hs_config ?
                    '<path class="hs_border" d="' + hs_config.path + '"/>' :
                    '<rect ' +
                      'class="hs_border" ' +
                      'width="' + hs_config.width + '" ' +
                      'height="' + hs_config.height + '" ' +
                      'x="' + hs_config.x + '" ' +
                      'y="' + hs_config.y + '"' +
                    '>' +
                    '<title>' + this.hs_aria.query_hs[0][j] + '</title>' +
                    '</rect>'
                  );

          if (is_answered) {
            html += '<g ' +
              'transform="translate(' + translate_x + ',' + translate_y + ') scale(6)"' +
              '>' +
              ((is_correct_answer) ? CHECKMARK : ((is_user_answer) ? ASTERISK : '')) +
              '</g>';
          }

          html += '</a>';
        }

        html += '</g>';
        html += ('general' in this.hs_aria ? '<title>' + this.hs_aria.general + '</title>' : '');
        html += '</svg>' +
                '</fieldset>';
      }

      // Get a possible feedback string for each option
      html += this.correct_incorrect_feedback();
      html = dom.createHTML( html );
      common.parseMathExpresions( html );

      return html;
    }
    else {
      return this._super.call(this, mode);
    }
  },

  evaluateAnswer: function () {
    if (this.is_hs_type) {
      var $container = $('.hs_query[data-query_index="' + this.query_index + '"] svg');
      var answer = 0;
      $container.each(function () {
        var $el = $(this);
        var $answer = $el.find('a[aria-checked=true]');
        if ($answer.length === 0) {
          return false;
        }
        else {
          $answer.each(function (index, element) {
            answer += +element.getAttribute('data-hs_index');
          });
        }
      });

      safe_log('evaluateAnswer: answer = ' + answer);

      var local_grade;

      if (answer > 0) {
        this.user_answer = answer;
        if (this.md.ans_cf == 9 && (answer == 1 || answer == 8)) {
          //this.user_answer_index = this.correct_answer_index;
          this.user_answer_index = 1;
          this.setGrade( 100 );
          local_grade = 100;
        }
        // set grade accordingly (if this.md.no_correct_answer is true, any answer is correct)
        else if ( this.md.ans_cf == answer || this.md.no_correct_answer == 'true' ) {
          //this.user_answer_index = this.correct_answer_index;
          this.user_answer_index = 1;
          this.setGrade( 100 );
          local_grade = 100;
        }
        else {
          this.user_answer_index = 0;
          this.setGrade( 0 );
          local_grade = 0;
        }

        safe_log('evaluateAnswer: user_answer_index = ' + this.user_answer_index);
        safe_log('evaluateAnswer: grade = ' + local_grade);
        safe_log('evaluateAnswer: correct_answer_index = ' + this.correct_answer_index);

        return true;
      }
      else {
        // if android and mc query, then clear feedback
        if (platform.android || platform.ios || platform.mac) {
          window.player.updateLiveRegion();
        }

        var text = this.parent_question.queries.length > 1
          ? 'Please answer all questions.' : 'Choose one option from the list.';
        var textTitle = this.parent_question.queries.length > 1
          ? 'Please note' : 'Please note';

        var $fromInitBtn = $('#question_submit_button_' + (this.query_index + 1) + ':visible'),
          $fromElement = $fromInitBtn.length ?
            $fromInitBtn :
            $('#question_submit_button_' + this.parent_question.index);

        window.Local_Dialog.open( '<p style=\"text-align: center;\">' + text + '</p>', {
          'draggable': false,
          'title': textTitle,
          'width': 290,
          'buttons': [
            {text: 'OK', click: window.Local_Dialog.close}
          ],
          'from': $fromElement
        } );
        return false;
      }
    }
    else {
      return this._super();
    }
  }
} );

var getHTML = function (regions, hoverable) {
  var html = '';
  var i;
  var j;

  for (i = 0; i < regions.length; i++) {
    var imageParams = regions[i];

    html += '<div class="hs_container">' +
      '<svg version="1.1"' +
      ' xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"' +
      ' data-field_index="' + i + '" x="0px" y="0px" width="100%" height="100%"' +
      ' viewBox="0 0 ' + imageParams.width + ' ' + imageParams.height +
      '" xml:space="preserve" tabindex="-1" focusable="false" role="group">';
    html += '<title id="title-2">Scheme of the spinothalamic tract.</title>';
    html += '<image overflow="visible" x="0" y="0"' +
      ' width="' + imageParams.width + '" height="' + imageParams.height +
      '" xlink:href="' + imageParams.src + '" tabindex="-1" aria-labelledby="title-2"> </image>';
    html += '<g>';

    for (j = 0; j < imageParams.hs.length; j++) {
      var stroke = imageParams.hs[j].stroke || '';
      var strokeWidth = imageParams.strokeWidth || '';
      var fill = imageParams.hs[j].fill || '';
      var style = '';

      if (stroke) stroke = 'stroke:' + stroke + ';';
      if (strokeWidth) strokeWidth = 'stroke-width:' + strokeWidth + ';';
      if (fill) fill = 'fill:' + fill + ';';
      style = stroke + strokeWidth + fill;

      if (hoverable) {
        html += '<a class="hs_item" xlink:href="#"' +
          ' data-field_index="' + i + '" data-hs_index="' + j + '"' +
          ('controlled_id' in imageParams.hs[j] ? ' data-controlled_id="' +
          imageParams.hs[j].controlled_id + '"' : '') +
          ('aria_label' in imageParams.hs[j] ? ' aria-label="' + imageParams.hs[j].aria_label + '"' : '') +
          ' role="button"' +
          ' style="fill-opacity: 1;" aria-pressed="false">' +
          ('path' in imageParams.hs[j] ?
            '<path class="hs_border" style="' + style + '" d="' + imageParams.hs[j].path + '"/>' :
            '<rect class="hs_border" style="' + style + '" width="'
              + imageParams.hs[j].width + '" height="' + imageParams.hs[j].height +
              '" x="' + imageParams.hs[j].x + '" y="' + imageParams.hs[j].y + '"/>') +
          '</a>';
      }
      else {
        html += '<path class="hs_border" style="' + style +
          '" d="' + imageParams.hs[j].path + '"/>';
      }
    }

    html += '</g>';
    html += ('aria_label' in imageParams ? '<title>' + imageParams.aria_label + '</title>' : '');
    html += '</svg></div>';
  }

  return html;
};

MC_Query = ProjectHSQuery;

window.player = new ChapterPlayer();

/**
 *
 * @param {object} selector
 * @param {array} feedback
 * @param {array} speed
 */
function init (selector, feedback, speed) {
  /**
   *
   */
  function showFeedback () {
    var feedback_block = container.querySelector('.slide_7_feedback');
    var html = options.feedback[options.step];

    if (html !== '') {
      $(feedback_block).html('<div class="question_feedback" style="display: block;"><div ' +
        'class="question_feedback_head">' +
        'Feedback</div><div class="question_feedback_part">' +
        options.feedback[options.step] +
        '</div></div>');
      player.updateLiveRegion(html);
      player.setTermRefHandlers.call(null, container);
    }
  }

  /**
   *
   */
  function addHandlers () {
    var start_button = container.querySelector('.start_button');
    var next_button = container.querySelector('.next_button');
    var prev_button = container.querySelector('.prev_button');
    var circle = container.querySelector('.circle');
    start_button.setAttribute('aria-live', 'polite');
    start_button.addEventListener('click', function (event) {
      event.preventDefault();
      if (options.start) {
        container.querySelector('.start_button').innerText = 'Start';
        options.step = 0;
        changeButtonState('disable');
      }
      else {
        container.querySelector('.start_button').innerText = 'Stop';
        changeButtonState('enable');
        animate();
      }
      options.start = !options.start;
    });
    next_button.addEventListener('click', function (event) {
      safe_log('next_button caught');
      safe_log(options);
      safe_log(this);
      var widget_id = $(this).parent().parent().parent().parent().attr('id');
      safe_log('widget_id = ' + widget_id);
      event.preventDefault();
      options.step += 1;
      if (options.step > 2) {
        options.step = 3;
        this.disabled = true;
        if (widget_id === 'screen7_widget_1') {
          player.screen7_widget_1_completed = true;
        }
        else if (widget_id === 'screen7_widget_2') {
          player.screen7_widget_2_completed = true;
        }
        if (player.screen7_widget_1_completed && player.screen7_widget_2_completed) {
          player.completeSectionTask();
        }
      }
      if (options.step == 1) {
        prev_button.disabled = true;
      }
      else {
        prev_button.disabled = false;
      }
      options.path = container.querySelector('#path' + options.step);
      $(options.path).effect('pulsate', {times: 3}, 300 );
      options.point_offset = options.offset;
      circle.style.display = 'inline';
      showFeedback();
    });
    prev_button.addEventListener('click', function (event) {
      event.preventDefault();
      options.step -= 1;
      if (options.step < 2) {
        options.step = 1;
        this.disabled = true;
      }
      options.path = container.querySelector('#path' + options.step);
      $(options.path).effect('pulsate', {times: 3}, 300 );
      options.point_offset = options.offset;
      next_button.disabled = false;
      circle.style.display = 'inline';
      showFeedback();
    });
    next_button.disabled = true;
    prev_button.disabled = true;
  }

  /**
   *
   * @param {string} state
   */
  function changeButtonState (state) {
    var next_button = container.querySelector('.next_button');
    var prev_button = container.querySelector('.prev_button');
    var circle = container.querySelector('.circle');
    var state = (state != 'enable');
    switch (options.step) {
      case 0: {
        next_button.disabled = state;
        prev_button.disabled = true;
        circle.style.display = 'none';
        $(container).find('.slide_7_feedback').empty();
        break;
      }
      case 3: {
        next_button.disabled = true;
        prev_button.disabled = state;
        break;
      }
      default: {
        next_button.disabled = state;
        prev_button.disabled = state;
        break;
      }
    }
  }

  /**
   *
   * @param {number} offset
   */
  function movePoint (offset) {
    var point_on_path = options.path.getPointAtLength(offset);
    point_on_path.x = +point_on_path.x + options.path.transform.baseVal.getItem(0).matrix.e;
    point_on_path.y = +point_on_path.y + options.path.transform.baseVal.getItem(0).matrix.f;
    options.point.move(point_on_path, options.step_offset[options.step]);
  }

  /**
   *
   * @param {number} offset
   */
  function moveLines (offset) {
    options.animation_container.setAttribute('transform', 'translate(-' + offset + ' 0)');
  };

  /**
   *
   */
  function animate () {
    var start = performance.now();
    var dx = options.offset;
    requestAnimationFrame(function move (time) {
      var timePassed = time - start;
      options.offset = dx + timePassed/100;
      if (options.step !== 0) {
        movePoint((options.speed[options.step].point_speed * (options.offset -
          options.point_offset) % options.path_limits[options.step].end) + options.path_limits[options.step].start);
      }
      moveLines(options.offset);
      if (options.offset - options.last_offset > options.speed[options.step].line_speed) {
        var line = new Line(options.offset, options.animation_container);
        line.add();
        options.lines.push(line);
        options.last_offset = options.offset;
      }
      if (options.start) {
        var offset = +options.lines[0].LINE_X - options.offset;
        if (offset < 0) {
          options.lines[0].remove();
          options.lines.shift();
        }
        requestAnimationFrame(move);
      }
    });
  }

  var container = document.querySelector(selector);
  var options = {};

  options.animation_container = container.querySelector('.cls-23');
  options.path = container.querySelector('.cls-2');
  options.path_limits = [
    {
      start: 0,
      end: 0,
    },
    {
      start: 37.5,
      end: 85,
    },
    {
      start: 55,
      end: 26,
    },
    {
      start: 170,
      end: 115,
    }
  ];
  options.offset = 0;
  options.point_offset = 0;
  options.last_offset = 0;
  options.step = 0;
  options.start = false;
  options.lines = [];
  options.point = [];
  options.delta = 12;
  options.speed = speed;
  options.step_offset = [
    {x: 0, y: 0},
    {x: 1.3, y: -1.3},
    {x: 0.3, y: -0.3},
    {x: -0.5, y: -1.2}
  ];
  options.feedback = feedback;
  var line = new Line(options.offset, options.animation_container);
  var point = new Point(-2, -2, container.querySelector('svg'));
  line.add();
  point.add();
  options.lines.push(line);
  options.point = point;
  addNavigation(container);
  addHandlers();
}

/**
 *
 * @param {object} container
 */
function addNavigation (container) {
  var navigation_block = container.querySelector('[data-type=box_inner]');
  var start_button = UI_Elements.get_button_html({
    id: '',
    extra_class: 'toolbar_button prev_next_buttons control_button start_button',
    label: 'Start',
    fn: ''
  });
  var next_button = UI_Elements.get_button_html({
    id: '',
    extra_class: 'toolbar_button prev_next_buttons control_button next_button',
    label: 'Next',
    fn: ''
  });
  var prev_button = UI_Elements.get_button_html({
    id: '',
    extra_class: 'toolbar_button prev_next_buttons control_button prev_button',
    label: 'Prev',
    fn: ''
  });
  $(navigation_block)
    .prepend('<div>' + '<div>' + start_button + '</div>' + '<div>' + prev_button + next_button + '</div>' +
      '<div class="question_action_div slide_7_feedback"></div>' +
      '</div>');
}

var BaseElement = Class.extend({
  _element: {},
  init: function (CONTAINER) {
    this.CONTAINER = CONTAINER;
    this._create();
  },
  _create: function () {
  },
  add: function () {
    this.CONTAINER.appendChild(this._element);
  },
  remove: function () {
    this.CONTAINER.removeChild(this._element);
  }
});

var Line = BaseElement.extend({
  LINE_X: 75.77,
  LINE_Y1: 2,
  LINE_Y2: 24.43,
  init: function (offset, CONTAINER) {
    this.offset = offset || 0;
    this.LINE_X = this.LINE_X + this.offset;
    this._super(CONTAINER);
  },
  _create: function () {
    var line = document.createElementNS('http://www.w3.org/2000/svg', 'line');
    line.setAttribute('x1', this.LINE_X);
    line.setAttribute('x2', this.LINE_X);
    line.setAttribute('y1', this.LINE_Y1);
    line.setAttribute('y2', this.LINE_Y2);
    this._element = line;
  }
});

var Point = BaseElement.extend({
  R: 2,
  init: function (x, y, CONTAINER) {
    this.X = x;
    this.Y = y;
    this._super(CONTAINER);
  },
  _create: function () {
    var circle = document.createElementNS('http://www.w3.org/2000/svg', 'circle');
    circle.setAttribute('x', this.X);
    circle.setAttribute('y', this.Y);
    circle.setAttribute('r', this.R);
    circle.setAttribute('id', 'impulse');
    circle.setAttribute('class', 'circle');
    this._element = circle;
  },
  move: function (point_on_path, offset) {
    var x = point_on_path.x + offset.x;
    var y = point_on_path.y + offset.y;
    this._element.setAttribute('transform', 'translate(' + x + ' ' + y + ')');
  }
});


/***/ }),

/***/ 40:
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),

/***/ 53:
/***/ (function(module, exports) {

var getSVG = '<svg xmlns="http://www.w3.org/2000/svg" data-name="Layer 1" viewBox="0 0 247.45 142.47">' +
  '<title>Somatosensory_screen7</title>' +
  '<path class="cls-1" d="M107.85,132.79a2.65,2.65,0,1,0-1.87,0l.18,0v3.57H93.35v1.5h81.47l5.47,3.37v0a4.73,4.73,0,0,' +
  '1-1.67-5.86,3.48,3.48,0,0,1,1.52-1.88v-.07l-5.58,3h-36c11.08-5.36,23.36-23.63,26.76-28.94l6-3.06,0,0a4.72,4.72,' +
  '0,0,1-6.68-4.36l-.06,0-.34,6.38c-3.54,5.51-19.91,30-31.37,30H107.66v-3.58Z" ' +
  'transform="translate(-18.48 -15.43)" />' +
  '<path class="cls-2" d="M108.43,68.47a2.57,2.57,0,0,0,1.11-2.21,2.65,2.65,0,0,0-5.3,0,2.74,2.74,0,0,0,1.08,' +
  '2.26l.31.15v2.9h-13v3h67.67c4.61,0,8.5,3,8.5,6.5v9.46L166.2,95h0A4.73,4.73,0,0,1,172,93.08a4.68,4.68,0,0,1,2.19,' +
  '1.8h.07l-2.45-4.36V81.05c0-5.24-5.16-9.5-11.5-9.5H142.09a11.46,11.46,0,0,0,3.77-8.49V55.23h2.33l-3.91-12.77-3.91,' +
  '12.77h2.49v7.83a8.51,8.51,0,0,1-8.33,8.49H108.12V68.62Z" transform="translate(-18.48 -15.43)" id="path1"/>' +
  '<line class="cls-3" x1="166.38" y1="99.76" x2="172.73" y2="92.54" />' +
  '<line class="cls-4" x1="166.38" y1="99.76" x2="172.73" y2="92.54" />' +
  '<text class="cls-5" transform="translate(164.36 90.49)">' +
  '<tspan class="cls-6">Interneuron</tspan>' +
  '</text>' +
  '<circle class="cls-11" cx="180.18" cy="94.75" r="4.37" transform="translate(66.12 259.07) rotate(-89.74)" />' +
  '<text class="cls-12" transform="translate(158.02 83.52) rotate(0.28)">+</text>' +
  '<circle class="cls-11" cx="185.35" cy="147.11" r="4.37" transform="translate(18.91 316.36) rotate(-89.74)" />' +
  '<text class="cls-12" transform="translate(163.19 135.88) rotate(0.28)">+</text>' +
  '<circle class="cls-13" cx="139.49" cy="87.09" r="4.37" transform="translate(0.01 0.01)"/>' +
  '<text class="cls-12" transform="translate(136.41 90.3)">–</text>' +
  '<circle class="cls-13" cx="176.16" cy="112.05" r="4.37" transform="translate(0.01 0.01)"/>' +
  '<text class="cls-12" transform="translate(173.08 115.27)">–</text>' +
  '<rect class="cls-14" x="84.62" y="0.25" width="82.19" height="24.43" />' +
  '<text class="cls-5" transform="translate(85.52 9.95)">' +
  '<tspan class="cls-15">Fine-touch and pressure</tspan>' +
  '<tspan class="cls-15" x="5.72" y="9.5">pathway to the brain</tspan>' +
  '</text>' +
  '<rect class="cls-14" x="0.25" y="41.78" width="77.72" height="33.1" />' +
  '<text class="cls-5" transform="translate(20.65 51.49)">' +
  '<tspan class="cls-15">Fine-touch</tspan>' +
  '<tspan class="cls-15" x="-18.62" y="9.5">and pressure pathway</tspan>' +
  '<tspan class="cls-15" x="-16.78" y="19">from body receptors</tspan>' +
  '</text>' +
  '<rect class="cls-20" x="0.6" y="104.35" width="75.77" height="33.1" />' +
  '<text class="cls-5" transform="translate(23.81 114.06)">' +
  '<tspan class="cls-15">Pain and</tspan>' +
  '<tspan class="cls-15" x="-21.8" y="9.5">temperature pathway</tspan>' +
  '<tspan class="cls-15" x="-20.47" y="19">from body receptors</tspan>' +
  '</text>' +
  '<rect class="cls-20" x="173.46" y="0.25" width="73.74" height="24.43" />' +
  '<text class="cls-5" transform="translate(174.07 9.95)">' +
  '<tspan class="cls-15">Pain and temperature</tspan>' +
  '<tspan class="cls-15" x="1.5" y="9.5">pathway to the brain</tspan>' +
  '</text>' +
  '<text class="cls-5" transform="translate(80.73 66.62)">Large<tspan x="0" y="9.5">(myelinated)</tspan>' +
  '</text>' +
  '<text class="cls-5" transform="translate(80.73 130.97)">Small<tspan x="0" y="9.5">(unmyelinated)</tspan>' +
  '</text>' +
  '<path class="cls-21" d="M185.18,126.49c-1.79-19.45-6.67-23.16-10.61-26.14l-.56-.43a4,4,0,1,0-.65,1.39l.3.23c3.69,' +
  '2.79,8.26,6.27,10,24.85l-2.5,5.9h0a4.43,4.43,0,0,1,5.44-2.21,3.41,3.41,0,0,1,2,1.28h.07Z" ' +
  'transform="translate(-18.48 -15.43)" id="path2"/>' +
  '<path class="cls-1" d="M232.85,55.23l-3.91-12.77L225,55.23h3.09v70.83a9.26,9.26,0,0,1-9.25,9.25H189.21a4,4,0,1,0,' +
  '.13,1.5h29.53a10.76,10.76,0,0,0,10.75-10.75V55.23Z" transform="translate(-18.48 -15.43)" id="path3"/>' +
  '<rect class="cls-22" x="0.6" y="0.25" width="75.77" height="24.43">' +
  '</rect>' +
  '<g class="cls-23"></g>' +
  '</svg>';

module.exports = getSVG;


/***/ }),

/***/ 54:
/***/ (function(module, exports) {

if (NodeList.prototype.forEach === undefined) {
  NodeList.prototype.forEach = function (callback, thisObj) {
    Array.prototype.forEach.call(this, callback, thisObj);
  };
}


/***/ }),

/***/ 80:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(31);


/***/ })

},[80]);
//# sourceMappingURL=kolb_nia_winter2019_ch11_1.js.map

$('body').addClass('how_we_feel');