webpackJsonp([3],{

/***/ 32:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(41);

var ProjectPlayer = __webpack_require__(3);
var SubtypeMCQuery = __webpack_require__(5);
var ProjectGlossary = __webpack_require__(8);
var dom = __webpack_require__( 2 );
var CgDnd = __webpack_require__(6);
var svg = __webpack_require__(55);

CgDnd.prototype.resizeDnd = function () {
  console.log('CgDnd.prototype.resizeDnd');
  this._onResizeHandler();
};

ProjectGlossary.prototype.show_definition = function (el) {
  var jq = $(el);
  var index = jq.attr('data-term');
  var title = 'Glossary';
  if (index == '' || index == null) {
    index = jq.html();
  }
  if (index != '' && index != null) {
    index = index.toLowerCase();
    var term = player.glossary.terms[index];
    var html;
    if (term == null) {
      html = 'No definition found for ' + index;
    }
    else {
      html = '<strong>' + term.label + ':</strong> ' + term.definition;
    }
    if (index === 'berridge and robinson') {
      title = 'Source';
    }
    Local_Dialog.open(html, {
      'title': title,
      // "modal": false,
      // "draggable": true,
      'buttons': 'OK',
      'from': jq
    });
  }
};

var ProjectMCQuery = SubtypeMCQuery.extend({
  getHTML: function (mode) {
    var html = '';

    html += this.correct_incorrect_feedback();
    if (html != '') {
      html = dom.createHTML(html);
      $('#section_7_feedback').html(html);
    }

    return '';
  },
  postInit: function () {
    var html = '';
    html += '<div class="query_matching_table_div" id="query_matching_div">';

    for (var i = 0; i < this.choices.length; ++i) {
      html += '<div id=drag-item-' + i + ' class="query_matching_table_td_left"><div class="query_matching_item" ' +
        'answer_index="' + i + '">'
        + this.choices[i] + '</div></div>';
    }
    html += '</div>';
    html = dom.createHTML(html);
    $('#section_7_dnd_words').html(html);
  },
  evaluateAnswer: function () {
    if (player.section_7_complete) {
      this.setGrade(100);
    }

    return true;
  },
  correct_incorrect_feedback: function (mode, is_correct) {
    var html = '';
    this.user_answer_index = this.choices.indexOf(player.user_answer);
    if (this.user_answer_index != null && this.choices_fb[this.user_answer_index] != null) {
      if (player.user_answer_correct) {
        html += this.choices_fb[this.user_answer_index];
        $('#section_7_feedback').removeClass('incorrect');
      }
      else if (player.user_answer_data === 'item1') {
        html += 'This is a component of the ‘wanting’ pathway';
        $('#section_7_feedback').addClass('incorrect');
      }
      else if (player.user_answer_data === 'item2') {
        $('#section_7_feedback').addClass('incorrect');
        html += 'This is a component of the ‘liking’ pathway';
      }
    }
    $('#live-feedback').html(html);
    html = '<div class="query_mc_feedback_correct_incorrect">' + html + '</div>';
    return html;
  }
});

MC_Query = ProjectMCQuery;

var ChapterPlayer = ProjectPlayer.extend({
  initialize: function (isWithoutAccessibleTables) {
    this._super(isWithoutAccessibleTables);
    this.glossary = new ProjectGlossary();

  },
  initialize2: function () {
    this._super();

    var self = this;
    var html0 = dom.createHTML(svg.kolb_ch12_01),
        html1 = dom.createHTML(svg.kolb_ch12_02),
        html2 = dom.createHTML(svg.kolb_ch12_03);
    this.action_label = {
      section_2_button_1: '',
      section_2_button_2: '',
      section_2_button_3: '',
      section_2_button_4: '',
      section_4_button_1: 'Arrows appear showing how dopamin releases and acts on all listed structures of the brain.',
      section_4_button_2: 'Lines connecting all hotspots appear, showing their unified operation.',
      section_5_button_1: 'Arrows appear showing how dopamin releases and acts on all listed structures of the brain.',
      section_5_button_2: 'Lines connecting all hotspots appear, showing their unified operation.'
    };

    player.section_7_complete = false;
    this.section_with_widget.forEach( function (section) {
      self.initWidgetButton(section);
    });

    UI_Elements.update_button_label('question_submit_button_1', 'Check Your Answer');
    $('#question_action_div_2').remove();

    $('#section_2_widget>div').prepend(html0);
    $('#section_4_widget').prepend(html1);
    $('#section_5_widget').prepend(html2);
    console.log(html0);
  },
  show_finished_dnd: function() {
    safe_log('show_finished_dnd');

    $('#digfir_section_6').addClass('dnd_completed');

    $('#section_7_feedback').remove();
    $('#dnd_7_instructions').remove();

    $('#drop-area-1').find('p').remove();
    $('#drop-area-2').find('p').remove();

    $('#drop-area-1').removeAttr('tabindex').append('<h3>Wanting System</h3>');
    $('#drop-area-2').removeAttr('tabindex').append('<h3>Liking System</h3>');

    $('#drop-area-1').append('<ul></ul>');
    $('#drop-area-2').append('<ul></ul>');

    $('#drag-item-0').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-1 ul');
    $('#drag-item-6').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-1 ul');
    $('#drag-item-1').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-1 ul');
    $('#drag-item-4').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-1 ul');

    $('#drag-item-2').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-2 ul');
    $('#drag-item-3').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-2 ul');
    $('#drag-item-5').css('transform','unset').removeAttr('tabindex').wrap('<li></li>').parent().appendTo('#drop-area-2 ul');

  },
  show_section: function ( section_to_show ) {
    this._super(section_to_show);

    var c_section = this.section_currently_showing;

    this.last_animate_svg_path = undefined;

    switch (c_section) {
      case 4: {
        player.scrollTop = $('#section_4_widget').offset();
        break;
      }
      case 6: {
        // if we haven't completed the DnD feature on slide 7 then 
        // instantiate 
        if (this.get_LASX() < 7) {
          this.dnd = this.dnd || new CgDnd(this.dnd_setting);
          //console.log(this.dnd);
          //this.dnd.resizeDnd();
        }
        // Otherwise, we convert the feature into two lists
        else {
          if (!($('#digfir_section_6').hasClass('dnd_completed'))) {
            this.dnd = this.dnd || new CgDnd(this.dnd_setting);
            this.dnd.disable();
            this.dnd.destroy();
            this.show_finished_dnd();
          }
        }
        break;
      };
      default: ;
    }

    // for slide 3, we only want to show Next button if both video has
    // been watched and widget activity has been completed
    /*
    if (section_to_show == 2) {
      try {
        // we need to add logic for LASX in LP
        if (!player.savi_bc_videos.allVideosWatched(2) || 
            this.sections[2].task_completed !== true) {
            $('#next_button').hide();
        }
        else {
            $('#next_button').show();
        }
      }
      catch(e) {
        safe_log('show_section: ' + e.message);
      }
    }
    */
  },
  initWidgetButton: function (section) {
    var section_buttons = $('#section_' + section + '_widget button'),
        count = section_buttons.length,
        self = this;

    section_buttons.each(function (index, button) {
      this.addEventListener('click', {
        handleEvent: self.buttonClickHandler,
        section: section,
        count: count,
        id: button.id
      });
    });
  },
  getSVGContent: function (svg_id) {
    return document.getElementById(svg_id);
  },
  buttonClickHandler: function (event) {
    var button = event.currentTarget,
        isAriaPressed = button.getAttribute('aria-pressed') === 'true',
        isAriaChecked = button.getAttribute('aria-checked') === 'true',
        section_buttons = $('#section_' + this.section + '_widget button'),
        live_text = '';

    section_buttons.each(function () {
      this.setAttribute('aria-pressed', button.id === this.id ? isAriaPressed : 'false');
    });

    button.setAttribute('aria-pressed', isAriaPressed ? 'false' : 'true');
    button.setAttribute('aria-checked', 'true');

    if (!isAriaChecked) {
      $(button).append('<span class="query_correct_feedback_span" aria-hidden="true">&nbsp;</span>');
    }

    $('[id ^= "section_' + this.section + '_feedback_"]').hide();
    $('#section_2_widget path').each(function () {
      this.setAttribute('class', '');
    });
    if (!isAriaPressed) {
      live_text = player.action_label[button.id] +
        $('#' + button.getAttribute('data-index')).find('p:first-child').text();
      $('#' + button.getAttribute('data-index')).show().attr('tabindex', -1).focus();
      player.updateLiveRegion(live_text);
      console.log($('path#svg_' + button.getAttribute('data-index')));
      if (this.section == 2) {
        document.querySelector('path#svg_' + button.getAttribute('data-index')).setAttribute('class', 'fill_yellow');
      }
    }

    if (document.querySelectorAll('#section_' + this.section + '_widget ' +
      'button[aria-checked="true"]').length === this.count) {
//      player.showNextButton();
        if (player.section_currently_showing == 2) {
          player.sections[2].task_completed = true;
          // only show Next button if video has been watched
          //if (player.savi_bc_videos.allVideosWatched(2)) {
            player.completeSectionTask();
          //}
        }
        else {
          player.completeSectionTask();
        }
    }
    if (this.section !== 2) {
      player.animateSVG('section_' + this.section + '_svg', 'g#' + this.id);
      if (this.id === 'section_4_button_1' || this.id === 'section_5_button_1') {
        player.animatePath('section_' + this.section + '_svg', 'g#path g');
      }
    }
    $(document).scrollTop(player.scrollTop);
  },
  animateSVG: function (svg_id, svg_element) {
    if (this.last_animate_svg_element !== undefined) {
      $(this.getSVGContent(svg_id)).find(this.last_animate_svg_element).each(function () {
        $(this).stop(true);
        $(this).css({'opacity': 1});
      });

      if (this.last_animate_svg_path !== undefined && svg_element !== 'g#section_4_button_1' &&
        svg_element !== 'g#section_5_button_1') {
        $(this.getSVGContent(svg_id)).find(this.last_animate_svg_path).each(function () {
          $(this).stop(true, false);
          $(this).css({'opacity': 1});
        });
        this.last_animate_svg_path = undefined;
      }
    }

    if (this.last_animate_svg_element !== svg_element) {
      $(this.getSVGContent(svg_id)).find(svg_element).each(function () {
        $(this).effect('pulsate', {times: 5}, 600);
      });
      this.last_animate_svg_element = svg_element;
    }
    else {
      this.last_animate_svg_element = undefined;
    }
  },
  animatePath: function (svg_id, svg_path) {
    var duration = 600;
    if (this.last_animate_svg_path !== undefined) {
      $(this.getSVGContent(svg_id)).find(this.last_animate_svg_path).each(function () {
        $(this).stop(true, false);
        $(this).css({'opacity': 1});
      });
    }
    if (this.last_animate_svg_path !== svg_path) {
      $(this.getSVGContent(svg_id)).find(svg_path).each(function () {
        $(this).effect('pulsate', {times: 5}, duration);
      });
      this.last_animate_svg_path = svg_path;
    }
    else {
      this.last_animate_svg_path = undefined;
    }
  }
});
window.player = new ChapterPlayer();

player.dnd_setting = {
  bounds: '#digfir_section_6',
  dragItems: [
    {
      node: '#drag-item-0',
      ariaLabel: 'drag-item-0',
      data: 'item1',
      className: 'custom-class',
      groups: ['#ventral']
    },
    {
      node: '#drag-item-1',
      ariaLabel: 'drag-item-1',
      data: 'item1',
      className: 'custom-class',
      groups: ['#nucleus']
    },
    {
      node: '#drag-item-2',
      ariaLabel: 'drag-item-2',
      data: 'item2',
      className: 'custom-class',
      groups: ['#Dopamine_text']
    },
    {
      node: '#drag-item-3',
      ariaLabel: 'drag-item-3',
      data: 'item2',
      className: 'custom-class',
      groups: ['#prefrontal']
    },
    {
      node: '#drag-item-4',
      ariaLabel: 'drag-item-4',
      data: 'item1',
      className: 'custom-class',
      groups: ['#Dopamine_text']
    },
    {
      node: '#drag-item-5',
      ariaLabel: 'drag-item-5',
      data: 'item2',
      className: 'custom-class',
      groups: ['#amygdala']
    },
    {
      node: '#drag-item-6',
      ariaLabel: 'drag-item-6',
      data: 'item1',
      className: 'custom-class',
      groups: ['#prefrontal']
    }
  ],
  dropAreas: [
    {
      node: '#drop-area-1',
      ariaLabel: 'Area 1',
      data: 'item1',
      className: 'custom-drop-area-class',
      maxItemsInDropArea: 7,
      initialAriaKeyboardDesc: 'Wanting'
    },
    {
      node: '#drop-area-2',
      ariaLabel: 'Area 2',
      data: 'item2',
      className: 'custom-drop-area-class',
      maxItemsInDropArea: 7,
      initialAriaKeyboardDesc: 'Liking'
    }
  ],
  helper: 'original',
  handler: 'h2',
  enabled: true,
  snap: true,
  commonDropAreasSettings: {
    snapAlignParams: {
      horizontalAlign: 'center',
      verticalAlign: 'top',
      withDroppedItemCSSMargins: true
    }
  },
  tooltipParams: {
    className: 'test',
    position: 'start'
  },
  onCreate: function (data) {
  },
  onDragStart: function (data) {
    $('.cg-dnd-tooltip').hide();
  },
  onDragMove: function (data) {
  },
  onDragStop: function (data, options) {
    if (options.dropArea) {
      player.user_answer = options.dragItem.node.textContent;
      player.user_answer_data = options.dragItem.data;
      if (options.dropArea.data === options.dragItem.data) {
        //console.log('correct');
        //console.log(player.dnd);
        player.user_answer_correct = true;
        $(options.dropArea.node).height((options.dropArea.innerDragItemsCount + 1)* 50);
        if (options.remainingDragItems.length === 0) {
          player.section_7_complete = true;
        }
      }
      else {
        //console.log('incorrect');
        player.user_answer_correct = false;
        options.dragItem.reset();
      }
      player.activity.submit_question(2);
    }
  },
  onDragItemSelect: function (data, options) {
    options.dropAreas[0].focus();
  },
  onDropAreaSelect: function (data, options) {
    if (options.currentDraggedItem) {
      options.currentDraggedItem.placeToDropArea({dropArea: options.dropArea});
    }
    else if (options.droppedItems.length) {
      options.droppedItems[0].focus({delay: 0});
    }
  }
};
player.BUTTONS = {
  section_5: {
    waiting_button: {
      id: 'waiting_button',
        extra_class: 'standard_button toolbar_button prev_next_buttons control_button ui-button ui-widget ' +
      'ui-state-default ui-corner-all ui-button-text-only ui-state-hover',
        label: 'Waiting',
        fn: 'player.showAnimation("waiting_feedback", "#Wanting", "brain")'
    },
    liking_button: {
      id: 'liking_button',
        extra_class: 'standard_button toolbar_button prev_next_buttons control_button ui-button ui-widget ' +
      'ui-state-default ui-corner-all ui-button-text-only ui-state-hover',
        label: 'Liking',
        fn: 'player.showAnimation("liking_feedback", "#Liking", "brain")'
    },
    block: '#section_5_animation_block'
  },
  section_6: {
    waiting_button: {
      id: 'waiting_button2',
        extra_class: 'standard_button toolbar_button prev_next_buttons control_button ui-button ui-widget ' +
      'ui-state-default ui-corner-all ui-button-text-only ui-state-hover',
        label: 'Waiting',
        fn: 'player.showAnimation("waiting_feedback2", "#Wanting", "brain2")'
    },
    liking_button: {
      id: 'liking_button2',
        extra_class: 'standard_button toolbar_button prev_next_buttons control_button ui-button ui-widget ' +
        'ui-state-default ui-corner-all ui-button-text-only ui-state-hover',
        label: 'Liking',
        fn: 'player.showAnimation("liking_feedback2", "#Liking", "brain2")'
    },
    block: '#section_6_animation_block'
  }
};
player.section_with_widget = [2, 4, 5];


/***/ }),

/***/ 41:
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),

/***/ 55:
/***/ (function(module, exports) {

var
  kolb_ch12_01 = '<svg xmlns="http://www.w3.org/2000/svg" xmlns:svg="http://www.w3.org/2000/svg" ' +
    'xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Layer_1" x="0px" y="0px" width="215.034px" ' +
    'height="184.893px" viewBox="0 0 215.034 184.893" enable-background="new 0 0 215.034 184.893" ' +
    'xml:space="preserve">' +
    '<g id="g18">' +
    '<g id="g16" transform="translate(1.33398e-6)">' +
    '<image xlink:href="./asset/images/ch12/n766bd4ef.jpg" overflow="visible" width="1450" height="1190" ' +
    'transform="matrix(0.1223,0,0,0.1223,20.5439,9.7905)" id="image14" style="overflow:visible">' +
    '</image>' +
    '</g>' +
    '</g>' +
    '<line fill="none" stroke="#FFFFFF" stroke-width="1.897" x1="16.646" y1="36.332" x2="33.857" y2="54.416" ' +
    'id="line22" />' +
    '<line fill="none" stroke="#000000" stroke-width="0.6" x1="16.646" y1="36.332" x2="33.857" y2="54.416" ' +
    'id="line24" />' +
    '<line fill="none" stroke="#FFFFFF" stroke-width="1.897" x1="93.274" y1="130.415" x2="109.525" y2="100.036" ' +
    'id="line26" />' +
    '<line fill="none" stroke="#000000" stroke-width="0.6" x1="93.274" y1="130.415" x2="109.525" y2="100.036" ' +
    'id="line28" />' +
    '<line fill="none" stroke="#FFFFFF" stroke-width="1.897" x1="139.132" y1="163.847" x2="139.132" y2="148.166" ' +
    'id="line30" />' +
    '<line fill="none" stroke="#000000" stroke-width="0.6" x1="139.132" y1="163.847" x2="139.132" y2="148.166" ' +
    'id="line32" />' +
    '<line fill="none" stroke="#FFFFFF" stroke-width="1.897" x1="172.253" y1="131.679" x2="164.294" y2="123.292" ' +
    'id="line34" />' +
    '<line fill="none" stroke="#000000" stroke-width="0.6" x1="172.253" y1="131.679" x2="164.294" y2="123.292" ' +
    'id="line36" />' +
    '<line fill="none" stroke="#FFFFFF" stroke-width="1.897" x1="33.857" y1="107.93" x2="73.542" y2="83.552" ' +
    'id="line38" />' +
    '<line fill="none" stroke="#000000" stroke-width="0.6" x1="33.857" y1="107.93" x2="73.542" y2="83.552" ' +
    'id="line40" />' +
    '<text transform="matrix(1 0 0 1 78.5127 139.3999)" id="text46">' +
    '<tspan x="0" y="0" font-family="\'Univers-Condensed\'" font-size="8" id="tspan42">V</tspan>' +
    '<tspan x="4.176" y="0" font-family="\'Univers-Condensed\'" font-size="8" id="tspan44">entral </tspan>' +
    '</text>' +
    '<text transform="matrix(1 0 0 1 78.5127 148.3999)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text48">tegmenum</text>' +
    '<text transform="matrix(1 0 0 1 114.9932 172.8315)" id="text54">' +
    '<tspan x="0" y="0" font-family="\'Univers-Condensed\'" font-size="8" id="tspan50">T</tspan>' +
    '<tspan x="3.264" y="0" font-family="\'Univers-Condensed\'" font-size="8" id="tspan52">o spinal cord' +
    '</tspan>' +
    '</text>' +
    '<text transform="matrix(1 0 0 1 18.2085 116.9683)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text56">Nucleus</text>' +
    '<text transform="matrix(1 0 0 1 18.2085 125.9683)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text58">accumbens in</text>' +
    '<text transform="matrix(1 0 0 1 18.2085 134.9683)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text60">basal ganglia</text>' +
    '<text transform="matrix(1 0 0 1 6.4165 24.96)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text62">Prefrontal</text>' +
    '<text transform="matrix(1 0 0 1 6.4165 33.96)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text64">cortex</text>' +
    '<text transform="matrix(1 0 0 1 172.8008 138.6558)" font-family="\'Univers-Condensed\'" font-size="8" ' +
    'id="text66">Cerebellum</text>' +
    '<path d="m 32.904687,45.635667 c -2.834974,0.679819 -3.894822,4.509018 -4.896531,7.246866 ' +
    '-1.466547,4.008335 -1.252386,8.464432 -1.371028,12.73098 -0.105397,3.790248 0.0766,7.602827 0.587584,11.359952 ' +
    '0.486694,3.578559 1.591752,6.627198 3.32964,9.793062 1.643909,2.994665 3.485376,6.04791 6.26756,8.03031 ' +
    '2.18775,1.558845 4.597623,3.970206 7.246866,3.525503 10.107209,-1.696599 21.740597,-21.740597 ' +
    '21.740597,-21.740597 0,0 -5.034855,-0.749139 -7.051005,-2.154474 -1.681807,-1.172285 -3.405998,-2.870877 ' +
    '-3.721363,-4.896531 -0.330361,-2.121976 0.976812,-4.275861 2.154474,-6.071698 0.734595,-1.120197 ' +
    '2.937918,-2.742057 2.937918,-2.742057 0,0 -17.136431,-17.500459 -27.224712,-15.081316 z" ' +
    'id="svg_section_2_feedback_3" />' +
    '<path d="m 75.406575,76.777604 c -2.359295,-0.02062 -4.661682,0.893599 -6.855143,1.762751 ' +
    '-1.385407,0.548963 -2.884343,1.080292 -3.917225,2.154474 -0.809481,0.841848 -1.566889,1.965889 ' +
    '-1.566889,3.133779 0,1.313877 0.741456,2.698925 1.762751,3.525502 1.415512,1.145633 3.503988,1.006958 ' +
    '5.288253,1.371029 2.587386,0.527944 5.194527,1.239206 7.834449,1.175168 1.996813,-0.04844 4.176747,-0.125072 ' +
    '5.875837,-1.175168 1.266427,-0.782695 2.490703,-2.0581 2.742058,-3.525502 0.243997,-1.424445 ' +
    '-0.493807,-2.964583 -1.371029,-4.113086 -1.000187,-1.309495 -2.614348,-2.057269 -4.113086,-2.742057 ' +
    '-1.786407,-0.816226 -3.716006,-1.549727 -5.679976,-1.56689 z" id="svg_section_2_feedback_2" />' +
    '<path d="m 109.68229,94.405115 c -1.34587,0.01213 -2.83749,0.551861 -3.72136,1.56689 ' +
    '-0.66559,0.764352 -0.75654,1.924747 -0.78345,2.937918 -0.0337,1.267197 0.1429,2.627457 0.78345,3.721367 ' +
    '0.70137,1.19778 1.80209,2.35063 3.13378,2.74205 1.70967,0.50252 3.87259,0.29887 5.28825,-0.78344 ' +
    '0.9058,-0.6925 1.22559,-2.0029 1.37103,-3.13378 0.16019,-1.24556 -0.0508,-2.586026 -0.58758,-3.721364 ' +
    '-0.33601,-0.710736 -0.92357,-1.310885 -1.56689,-1.762751 -1.15081,-0.808323 -2.51096,-1.579559 ' +
    '-3.91723,-1.56689 z" id="svg_section_2_feedback_1" />' +
    '<path d="m 131.22703,91.271335 -2.5462,1.371029 -0.19586,1.958612 -1.17517,1.56689 c 0,0 ' +
    '-0.66848,1.035154 -0.9793,1.56689 -0.41282,0.70624 -1.00143,1.355092 -1.17517,2.154474 -0.19462,0.89544 ' +
    '-0.0203,1.85156 0.19586,2.74206 0.23454,0.96637 0.73727,1.84923 1.17517,2.74205 0.29599,0.60349 ' +
    '0.60176,1.20663 0.9793,1.76276 0.52118,0.76771 1.25837,1.37562 1.76275,2.15447 0.55548,0.85775 ' +
    '0.60493,2.06576 1.37103,2.74206 0.88236,0.77893 2.29684,0.61072 3.32964,1.17516 0.6532,0.35699 ' +
    '1.68803,0.6304 1.76276,1.37103 0.0604,0.59888 -0.7662,0.92939 -1.17517,1.37103 -0.69007,0.74519 ' +
    '-1.56063,1.33055 -2.15448,2.15447 -0.4268,0.59215 -0.8116,1.24821 -0.9793,1.95862 -0.18,0.76249 ' +
    '-0.16807,1.58513 0,2.35033 0.20053,0.91301 0.68373,1.75104 1.17517,2.5462 0.65933,1.06682 1.45965,2.05502 ' +
    '2.35033,2.93792 0.82554,0.81833 2.11,1.17893 2.74206,2.15447 0.43911,0.67774 0.58758,2.35033 0.58758,2.35033 ' +
    '0,0 -0.47784,0.77134 -0.39172,1.17517 0.22165,1.03943 1.49273,1.5187 2.15447,2.35034 0.78929,0.99194 ' +
    '1.19818,2.30166 2.15448,3.13378 0.66078,0.57498 1.48639,1.03082 2.35033,1.17516 0.97447,0.16281 ' +
    '2.0751,0.0896 2.93792,-0.39172 0.81036,-0.45202 1.38964,-1.30489 1.76275,-2.15447 0.18563,-0.42268 ' +
    '0.19586,-1.37103 0.19586,-1.37103 0,0 0.7388,1.23686 1.37103,1.37103 0.88954,0.18877 1.70754,-0.62779 ' +
    '2.5462,-0.97931 0.72754,-0.30494 1.40631,-0.72917 2.15447,-0.9793 0.57086,-0.19086 1.1911,-0.20327 ' +
    '1.76275,-0.39173 0.61067,-0.20132 1.24708,-0.39934 1.76275,-0.78344 0.48273,-0.35956 1.17517,-1.37103 ' +
    '1.17517,-1.37103 0,0 1.49935,-0.39005 2.15447,-0.78345 0.75301,-0.45219 1.23281,-1.26808 1.95862,-1.76275 ' +
    '0.60317,-0.41108 1.47023,-0.43682 1.95861,-0.9793 0.37322,-0.41456 0.25583,-1.11845 0.58758,-1.56689 ' +
    '0.63683,-0.86083 1.72498,-1.27146 2.5462,-1.95862 0.74435,-0.62284 2.15447,-1.95861 2.15447,-1.95861 ' +
    '0,0 1.21097,-1.80598 1.76275,-2.74205 0.4895,-0.83042 1.33175,-1.58305 1.37103,-2.5462 0.0465,-1.13924 ' +
    '-0.68968,-2.21956 -1.37103,-3.13378 -0.66438,-0.89145 -1.79292,-1.33675 -2.54619,-2.15447 -0.76103,-0.82614 ' +
    '-1.20446,-1.90964 -1.95862,-2.74206 -0.46597,-0.51432 -1.09498,-0.86216 -1.56689,-1.37103 -0.66591,-0.71806 ' +
    '-1.01921,-1.71301 -1.76275,-2.35033 -0.84268,-0.7223 -2.01713,-0.94723 -2.93792,-1.56689 -0.84607,-0.56938 ' +
    '-1.52429,-1.36055 -2.35033,-1.95862 -0.99777,-0.72241 -2.18529,-1.17261 -3.13378,-1.95861 -0.88936,-0.737 ' +
    '-1.44229,-1.83234 -2.35033,-2.546195 -1.05686,-0.830849 -2.40585,-1.214548 -3.52551,-1.958613 ' +
    '-0.96812,-0.643363 -1.87252,-1.383049 -2.74205,-2.154473 -0.75974,-0.67402 -1.40929,-1.464404 ' +
    '-2.15448,-2.154474 -0.88328,-0.817943 -1.81489,-1.582489 -2.74205,-2.350335 -0.64393,-0.533284 ' +
    '-1.95862,-1.56689 -1.95862,-1.56689 l -3.72136,-0.391722 -1.76275,0.783445 -3.32964,0.587584 z" ' +
    'id="svg_section_2_feedback_4" />' +
    '</svg>',
  kolb_ch12_02 = '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 ' +
    '289.25 149.6" role="img" aria-labelledby="uniqueTitleID" focusable="false" id="section_4_svg">' +
    '<title id="uniqueTitleID">A sagittal section of the rat\'s brain showing locations of brainstem, prefrontal ' +
    'cortex, striatum, nucleus accumbens, ventral pallidum and amygdala a s well as a source of dopamine in the ' +
    'ventral tegmentum. These all are components of wanting circuits. There are also several hotspots involved ' +
    'into liking circuits.</title>' +
    '<g id="Placed">' +
    '<g id="Kolb_CH12_02.tif">' +
    '<image id="Kolb_CH12_02" width="602" height="309" transform="scale(0.48)" ' +
    'xlink:href="./asset/images/ch12/kolb_ch12_02.png"/>' +
    '</g>' +
    '</g>' +
    '<g id="section_4_button_1">' +
    '<g id="wanting_text" data-name="Wanting text">' +
    '<g class="cls-6">' +
    ' <text class="cls-7" transform="translate(113.23 74.11)"><tspan class="cls-8">‘Wanting’</tspan></text>' +
    '</g>' +
    '<text class="cls-13" transform="translate(113.23 74.11)"><tspan class="cls-8">‘Wanting’</tspan></text>' +
    '</g>' +
    '</g>' +
    '<g id="path">' +
    '<path class="cls-1" d="M219.68,113.82l-5.59-7-1.1,1.5c-17-11.69-46.11-15.36-53.11-8.79a4.92,4.92,0,0,0-1.55,' +
    '4.6c-7.25-8.45-17.88-12.2-28.22-15.82-8.86-3.11-17.25-6-22.7-11.76l1.36-1.13-7.32-5.19,3.75,8.16,1.45-1.2c5.61,' +
    '5.91,14.14,8.9,23.14,12.06,7.74,2.71,15.66,5.5,22.13,10.29-8-5.38-16.32-7.23-25-9.14-7.33-1.61-14.91-3.28' +
    '-22.57-7.23C96.13,78.91,92.19,73,88,66.82c-2.68-4-5.45-8.1-9.45-11.76l1.2-1.43-8.14-3.8,5.15,7.36,1.14' +
    '-1.36a60.93,60.93,0,0,1,9.26,11.55c4.06,6,8.25,12.3,16.68,16.65,7.78,4,15.42,5.7,22.81,7.32,7.61,1.67,15,' +
    '3.3,22,7.34-8.9-4.56-22.72-8-49.9-8.12V88.73L90.1,91.05l8.67,2.32V91.56c39.67.19,50.57,7.44,59.51,14.88-11.85' +
    '-2.75-20.88.33-28.89,3.08-5.89,2-11.48,3.92-17.35,3.15l.37-1.71-9,.45,8,4.09.4-1.85a21.74,21.74,0,0,0,3,.21c5,' +
    '0,9.87-1.66,14.93-3.39A80.35,80.35,0,0,1,142,107a32.66,32.66,0,0,0-16.85,11.58l-1.49-1.11-3.31,8.35,7-5.57' +
    '-1.43-1.06c8.64-10.79,20.13-14.59,34.22-11.25l.12-.49.42-.27c-1.89-2.93-1.94-5.28-.14-7,3.2-3,12.18-3.82,22.85' +
    '-2.06s21.51,5.83,29,10.93l-1.06,1.44Z" transform="translate(-10 -10)"/>' +
    '<g>' +
    '<path class="cls-2" d="M160.28,107.47c-21.2-5-31.8,7.41-35.72,12.68" transform="translate(-10 -10)"/>' +
    '<polygon class="cls-3" points="113.64 107.49 110.33 115.84 117.38 110.27 113.64 107.49"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-2" d="M160.28,107.47c-22.6-6.42-34.8,8.67-49.91,5.42" transform="translate(-10 -10)"/>' +
    '<polygon class="cls-3" points="102.42 100.95 93.45 101.4 101.44 105.5 102.42 100.95"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-4" d="M160.28,107.47c-9.66-8.16-19.37-16.42-63.09-16.42" transform="translate(-10 -10)"/>' +
    '<polygon class="cls-5" points="88.78 78.73 80.11 81.05 88.78 83.38 88.78 78.73"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-4" d="M160.28,107.47c-17.05-18.8-36.18-13.55-56.18-23.89-14.28-7.38-16-20-27-29.19" ' +
    'transform="translate(-10 -10)"/>' +
    '<polygon class="cls-5" points="69.79 43.63 61.65 39.84 66.8 47.19 69.79 43.63"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-2" d="M160.28,107.47C147.33,88.12,118,90.19,106,75.67" transform="translate(-10 -10)"/>' +
    '<polygon class="cls-3" points="98.78 65.4 91.45 60.21 95.2 68.37 98.78 65.4"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-2" d="M160.28,107.47c-10.18-15.75,32.64-13.42,53.7,2.14" transform="translate(-10 -10)"/>' +
    '<polygon class="cls-3" points="201.33 100.54 209.69 103.82 204.09 96.8 201.33 100.54"/>' +
    '</g>' +
    '</g>' +
    '<g id="section_4_button_2">' +
    '<g>' +
    '<path class="cls-14" d="M65.84,49.32c19.73,18.12,18.74,42.15,32.93,55.89" transform="translate(-10 -10)"/>' +
    '<path class="cls-14" d="M65.84,49.32C70.94,59.48,80.39,75.16,79,97.76" transform="translate(-10 -10)"/>' +
    '<path class="cls-14" d="M79,97.76c4.51,5.33,14.4,7.45,19.74,7.45" transform="translate(-10 -10)"/>' +
    '<path class="cls-14" d="M98.77,105.21c25.13,9.12,72.77-23.11,125.51,15.3" transform="translate(-10 -10)"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-16" d="M65.84,49.32c19.73,18.12,18.74,42.15,32.93,55.89" transform="translate(-10 -10)"/>' +
    '<path class="cls-16" d="M65.84,49.32C70.94,59.48,80.39,75.16,79,97.76" transform="translate(-10 -10)"/>' +
    '<path class="cls-16" d="M79,97.76c4.51,5.33,14.4,7.45,19.74,7.45" transform="translate(-10 -10)"/>' +
    '<path class="cls-16" d="M98.77,105.21c25.13,9.12,72.77-23.11,125.51,15.3" transform="translate(-10 -10)"/>' +
    '</g>' +
    '<circle class="cls-15" cx="69.04" cy="87.76" r="5.33"/>' +
    '<circle class="cls-15" cx="55.85" cy="39.32" r="5.33"/>' +
    '<circle class="cls-15" cx="88.77" cy="95.21" r="5.33"/>' +
    '<circle class="cls-15" cx="213.61" cy="110.51" r="5.33"/>' +
    '<g class="cls-6">' +
    '<text class="cls-7" transform="translate(96.63 91.21)">‘Liking’</text>' +
    '</g>' +
    '<text class="cls-19" transform="translate(96.63 91.21)">‘Liking’</text>' +
    '</g>' +
    '<g id="dopamine_text" data-name="Dopamine text">' +
    '<g class="cls-20">' +
    '<text class="cls-7" transform="translate(142.67 105.63)"><tspan class="cls-21">Dopamine</tspan></text>' +
    '</g>' +
    '<text class="cls-22" transform="translate(142.67 105.63)"><tspan class="cls-21">Dopamine</tspan></text>' +
    '</g>' +
    '<g id="leaders">' +
    '<g>' +
    '<line class="cls-23" x1="46.17" y1="21.7" x2="52.86" y2="31.45"/>' +
    '<line class="cls-24" x1="46.17" y1="21.7" x2="52.86" y2="31.45"/>' +
    '</g>' +
    '<g>' +
    '<line class="cls-23" x1="92.63" y1="36.29" x2="87.2" y2="56.75"/>' +
    '<line class="cls-24" x1="92.63" y1="36.29" x2="87.2" y2="56.75"/>' +
    '</g>' +
    '<g>' +
    '<line class="cls-23" x1="224.56" y1="141.46" x2="224.56" y2="114.68"/>' +
    '<line class="cls-24" x1="224.56" y1="141.46" x2="224.56" y2="114.68"/>' +
    '</g>' +
    '<g>' +
    '<line class="cls-23" x1="45.04" y1="88.22" x2="62.51" y2="85.72"/>' +
    '<line class="cls-24" x1="45.04" y1="88.22" x2="62.51" y2="85.72"/>' +
    '</g>' +
    '<g>' +
    '<line class="cls-23" x1="60.57" y1="115.52" x2="81.04" y2="99.61"/>' +
    '<line class="cls-24" x1="60.57" y1="115.52" x2="81.04" y2="99.61"/>' +
    '</g>' +
    '<g>' +
    '<line class="cls-23" x1="91.56" y1="136.98" x2="107.03" y2="119.67"/>' +
    '<line class="cls-24" x1="91.56" y1="136.98" x2="107.03" y2="119.67"/>' +
    '</g>' +
    '</g>' +
    '<g id="Text">' +
    '<text class="cls-28" transform="translate(75.79 143.72)">Amygdala</text>' +
    '<text class="cls-32" transform="translate(12 88.67)">Nucleus<tspan x="0" y="8">accumbens</tspan></text>' +
    '<text class="cls-32" transform="translate(35.82 117.14)"><tspan class="cls-9">Ventral</tspan><tspan x="0" ' +
    'y="8">pallidum</tspan></text>' +
    '<text class="cls-32" transform="translate(22.31 16.4)"><tspan class="cls-35">Prefrontal</tspan><tspan ' +
    'class="cls-33" x="0" y="8">cortex</tspan></text>' +
    '<text class="cls-32" transform="translate(80.8 33.99)"><tspan class="cls-26">Striatrum</tspan></text>' +
    '<text class="cls-32" transform="translate(208.01 147.6)">Brainstem</text>' +
    '</g>' +
    '</svg>',
  kolb_ch12_03 = '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" ' +
    'viewBox="0 0 283.92 243.6" role="img" aria-labelledby="uniqueTitleID2" focusable="false" id="section_5_svg">' +
    '<title id="uniqueTitleID2">A sagittal section of the human brain showing locations of brainstem, prefrontal ' +
    'cortex, striatum, nucleus accumbens, ventral pallidum and amygdala a s well as a source of dopamine in the ' +
    'ventral tegmentum. These all are components of wanting circuits. There are also several hotspots involved ' +
    'into liking circuits.</title>' +
    '<g id="artboard">' +
    '<rect class="cls-1" width="283.92" height="243.6"/>' +
    '</g>' +
    '<g id="Placed">' +
    '<image width="591" height="507" transform="scale(0.48)" xlink:href="./asset/images/ch12/kolb_ch12_03.png"/>' +
    '</g>' +
    '<g id="section_5_button_2">' +
    '<g>' +
    '<path class="cls-2" d="M50.81,137s11-22.27,27.18-17.94c9.27,2.49,8.58,15.3,16.71,25,6.1,7.29,36.05,14.87,' +
    '59.61,13.69"/>' +
    '<path class="cls-2" d="M50.81,136.77c9.66,6.67,29.37,9.34,43.89,7.3"/>' +
    '<path class="cls-3" d="M50.81,136.77"/>' +
    '<path class="cls-3" d="M50.81,137s11-22.27,27.18-17.94c9.27,2.49,8.58,15.3,16.71,25,6.1,7.29,36.05,14.87,' +
    '59.61,13.69"/>' +
    '<path class="cls-3" d="M50.81,136.77c9.66,6.67,29.37,9.34,43.89,7.3"/>' +
    '</g>' +
    '<circle class="cls-4" cx="154.31" cy="157.76" r="5.33"/>' +
    '<circle class="cls-4" cx="94.7" cy="144.07" r="5.33"/>' +
    '<circle class="cls-4" cx="77.99" cy="119.07" r="5.33"/>' +
    '<circle class="cls-4" cx="50.81" cy="136.77" r="5.33"/>' +
    '<g id="Liking_text" data-name="Liking text">' +
    '<text class="cls-5" transform="translate(60.87 138.24) rotate(17.45)">‘</text>' +
    '<text class="cls-5" transform="translate(62.48 138.77) rotate(14.72)">L</text>' +
    '<text class="cls-5" transform="translate(66.14 139.72) rotate(12.26)">i</text>' +
    '<text class="cls-5" transform="matrix(0.98, 0.17, -0.17, 0.98, 67.99, 140.13)">k</text>' +
    '<text class="cls-5" transform="translate(71.84 140.8) rotate(7.93)">i</text>' +
    '<text class="cls-5" transform="translate(73.71 141.08) rotate(5.77)">n</text>' +
    '<text class="cls-5" transform="translate(78.16 141.53) rotate(2.79)">g</text>' +
    '<text class="cls-5" transform="translate(82.48 141.72) rotate(0.83)">’</text>' +
    '<text class="cls-6" transform="translate(60.87 138.24) rotate(17.45)">‘</text>' +
    '<text class="cls-6" transform="translate(62.48 138.77) rotate(14.72)">L</text>' +
    '<text class="cls-6" transform="translate(66.14 139.72) rotate(12.26)">i</text>' +
    '<text class="cls-6" transform="matrix(0.98, 0.17, -0.17, 0.98, 67.99, 140.13)">k</text>' +
    '<text class="cls-6" transform="translate(71.84 140.8) rotate(7.93)">i</text>' +
    '<text class="cls-6" transform="translate(73.71 141.08) rotate(5.77)">n</text>' +
    '<text class="cls-6" transform="translate(78.16 141.53) rotate(2.79)">g</text>' +
    '<text class="cls-6" transform="translate(82.48 141.72) rotate(0.83)">’</text>' +
    '</g>' +
    '</g>' +
    '<g id="section_5_button_1">' +
    '<g id="Wanting_text" data-name="Wanting text">' +
    '<text class="cls-13" transform="translate(73.23 70.62) rotate(-8.1)">‘</text>' +
    '<text class="cls-13" transform="translate(75.16 70.29) rotate(-5.24)">W</text>' +
    '<text class="cls-13" transform="translate(81.74 69.72) rotate(-2.17)">a</text>' +
    '<text class="cls-13" transform="matrix(1, 0, 0, 1, 85.65, 69.57)">n</text>' +
    '<text class="cls-13" transform="matrix(1, 0.04, -0.04, 1, 90.11, 69.6)">t</text>' +
    '<text class="cls-13" transform="translate(92.78 69.71) rotate(3.52)">i</text>' +
    '<text class="cls-13" transform="translate(94.71 69.81) rotate(5.32)">n</text>' +
    '<text class="cls-13" transform="translate(99.21 70.23) rotate(7.9)">g</text>' +
    '<text class="cls-13" transform="translate(103.5 70.85) rotate(9.6)">’</text>' +
    '<text class="cls-14" transform="translate(73.23 70.62) rotate(-8.1)">‘</text>' +
    '<text class="cls-14" transform="translate(75.16 70.29) rotate(-5.24)">W</text>' +
    '<text class="cls-14" transform="translate(81.74 69.72) rotate(-2.17)">a</text>' +
    '<text class="cls-14" transform="matrix(1, 0, 0, 1, 85.65, 69.57)">n</text>' +
    '<text class="cls-14" transform="matrix(1, 0.04, -0.04, 1, 90.11, 69.6)">t</text>' +
    '<text class="cls-14" transform="translate(92.78 69.71) rotate(3.52)">i</text>' +
    '<text class="cls-14" transform="translate(94.71 69.81) rotate(5.32)">n</text>' +
    '<text class="cls-14" transform="translate(99.21 70.23) rotate(7.9)">g</text>' +
    '<text class="cls-14" transform="translate(103.5 70.85) rotate(9.6)">’</text>' +
    '</g>' +
    '</g>' +
    '<g id="path">' +
    '<g>' +
    '<path class="cls-7" d="M143.81,131.63a34.45,34.45,0,0,0,2.36,12.45"/>' +
    '<path class="cls-9" d="M143.81,131.63a34.45,34.45,0,0,0,2.36,12.45"/>' +
    '<polygon class="cls-8" points="143.65 143.58 148.97 150.11 147.63 141.8 143.65 143.58"/>' +
    '<polygon class="cls-10" points="143.65 143.58 148.97 150.11 147.63 141.8 143.65 143.58"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-7" d="M143.81,131.63c-2.77,9.88-4.42,13.39-14.9,17.77"/>' +
    '<path class="cls-9" d="M143.81,131.63c-2.77,9.88-4.28,13.39-14.9,17.77"/>' +
    '<polygon class="cls-8" points="129.45 146.82 122.75 151.91 131.1 150.85 129.45 146.82"/>' +
    '<polygon class="cls-10" points="129.45 146.82 122.75 151.91 131.1 150.85 129.45 146.82"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-7" d="M143.81,131.63c-2.9,7-11.93,11.28-29.23,12.13"/>' +
    '<path class="cls-9" d="M143.81,131.63c-2.9,7-11.93,11.28-29.23,12.13"/>' +
    '<polygon class="cls-8" points="116.01 141.51 107.94 143.91 116.13 145.87 116.01 141.51"/>' +
    '<polygon class="cls-10" points="116.01 141.51 107.94 143.91 116.13 145.87 116.01 141.51"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-7" d="M145.3,120.07C145.6,107.2,128.56,103.32,108,108"/>' +
    '<path class="cls-11" d="M145.3,120.07C145.6,107.2,128.56,103.32,108,108"/>' +
    '<polygon class="cls-8" points="108.89 105.54 101.56 109.68 109.98 109.76 108.89 105.54"/>' +
    '<polygon class="cls-12" points="108.89 105.54 101.56 109.68 109.98 109.76 108.89 105.54"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-7" d="M145.3,120.07c.45-13.24-4.07-19.82-13.41-22.52"/>' +
    '<path class="cls-9" d="M145.3,120.07c.45-13.24-4.07-19.82-13.41-22.52"/>' +
    '<polygon class="cls-8" points="133.75 95.77 125.35 96.33 132.91 100.04 133.75 95.77"/>' +
    '<polygon class="cls-10" points="133.75 95.77 125.35 96.33 132.91 100.04 133.75 95.77"/>' +
    '</g>' +
    '<g>' +
    '<path class="cls-7" d="M145.3,120.07C162,62.13,31.53,57.23,39.54,105.25"/>' +
    '<path class="cls-11" d="M145.3,120.07C162,62.13,31.53,57.23,39.54,105.25"/>' +
    '<polygon class="cls-8" points="37.13 104.36 41.33 111.65 41.35 103.23 37.13 104.36"/>' +
    '<polygon class="cls-12" points="37.13 104.36 41.33 111.65 41.35 103.23 37.13 104.36"/>' +
    '</g>' +
    '</g>' +
    '<g id="Dopamine_text" data-name="Dopamine text">' +
    '<g class="cls-15">' +
    '<text class="cls-16" transform="translate(126.68 128)"><tspan class="cls-17">D</tspan><tspan x="5.36" y="0">' +
    'opamine</tspan></text>' +
    '</g>' +
    '<text class="cls-18" transform="translate(126.68 128)"><tspan class="cls-17">D</tspan><tspan x="5.36" y="0">' +
    'opamine</tspan></text>' +
    '</g>' +
    '<g id="Type">' +
    '<g id="striatum">' +
    '<g class="cls-19">' +
    '<text class="cls-20" transform="translate(94.69 99.02)">Striatum</text>' +
    '</g>' +
    '<text class="cls-35" transform="translate(94.69 99.02)"><tspan class="cls-21">Striatum</tspan></text>' +
    '</g>' +
    '<g id="amygdala">' +
    '<g class="cls-19">' +
    '<text class="cls-24" transform="translate(90.73 164.09)">A<tspan class="cls-25" x="4.87" y="0">m</tspan>' +
    '<tspan class="cls-26" x="11.44" y="0">y</tspan><tspan class="cls-27" x="15.13" y="0">gdala</tspan></text>' +
    '</g>' +
    '<text class="cls-36" transform="translate(90.73 164.09)">A<tspan class="cls-25" x="4.87" y="0">m</tspan>' +
    '<tspan class="cls-26" x="11.44" y="0">y</tspan><tspan class="cls-27" x="15.13" y="0">gdala</tspan></text>' +
    '</g>' +
    '<g id="nucleus">' +
    '<g class="cls-19">' +
    '<text class="cls-20" transform="translate(57.02 102.62)">Nucleus<tspan x="0" y="8">a</tspan><tspan ' +
    'class="cls-28" x="3.86" y="8">c</tspan><tspan x="7.39" y="8">cumbens</tspan></text>' +
    '</g>' +
    '<text class="cls-35" transform="translate(57.02 102.62)">Nucleus<tspan x="0" y="8">a</tspan><tspan ' +
    'class="cls-28" x="3.86" y="8">c</tspan><tspan x="7.39" y="8">cumbens</tspan></text>' +
    '</g>' +
    '<g id="ventral">' +
    '<g class="cls-19">' +
    '<text class="cls-20" transform="translate(92.98 126.15)"><tspan class="cls-29">V</tspan><tspan x="4.2" ' +
    'y="0">e</tspan><tspan class="cls-22" x="8.21" y="0">n</tspan><tspan class="cls-23" x="12.62" y="0">t</tspan>' +
    '<tspan class="cls-30" x="15.26" y="0">r</tspan><tspan x="17.84" y="0">al</tspan><tspan x="0" y="8">pallidum' +
    '</tspan></text>' +
    '</g>' +
    '<text class="cls-35" transform="translate(92.98 126.15)"><tspan class="cls-29">V</tspan><tspan x="4.2" ' +
    'y="0">e</tspan><tspan class="cls-22" x="8.21" y="0">n</tspan><tspan class="cls-23" x="12.62" y="0">t</tspan>' +
    '<tspan class="cls-30" x="15.26" y="0">r</tspan><tspan x="17.84" y="0">al</tspan><tspan x="0" y="8">pallidum' +
    '</tspan></text>' +
    '</g>' +
    '<g id="prefrontal">' +
    '<g class="cls-19">' +
    '<text class="cls-20" transform="translate(26.46 121.07)"><tspan class="cls-31">P</tspan><tspan class="cls-26" ' +
    'x="4.13" y="0">r</tspan><tspan x="6.66" y="0">ef</tspan><tspan class="cls-32" x="13.01" y="0">r</tspan><tspan ' +
    'x="15.54" y="0">o</tspan><tspan class="cls-22" x="19.94" y="0">n</tspan><tspan x="24.34" y="0">tal</tspan>' +
    '<tspan class="cls-28" x="0" y="8">c</tspan><tspan x="3.54" y="8">o</tspan><tspan class="cls-33" x="7.93" y="8">' +
    'r</tspan><tspan class="cls-28" x="10.74" y="8">t</tspan><tspan class="cls-21" x="13.34" y="8">e</tspan><tspan ' +
    'x="17.32" y="8">x</tspan></text>' +
    '</g>' +
    '<text class="cls-35" transform="translate(26.46 121.07)"><tspan class="cls-31">P</tspan><tspan class="cls-26" ' +
    'x="4.13" y="0">r</tspan><tspan x="6.66" y="0">ef</tspan><tspan class="cls-32" x="13.01" y="0">r</tspan><tspan ' +
    'x="15.54" y="0">o</tspan><tspan class="cls-22" x="19.94" y="0">n</tspan><tspan x="24.34" y="0">tal</tspan>' +
    '<tspan class="cls-28" x="0" y="8">c</tspan><tspan x="3.54" y="8">o</tspan><tspan class="cls-33" x="7.93" ' +
    'y="8">r</tspan><tspan class="cls-28" x="10.74" y="8">t</tspan><tspan class="cls-21" x="13.34" y="8">e</tspan>' +
    '<tspan x="17.32" y="8">x</tspan></text>' +
    '</g>' +
    '<g id="brainstem">' +
    '<g class="cls-19">' +
    '<text class="cls-20" transform="translate(130.01 170.32)">B<tspan class="cls-34" x="4.34" y="0">r</tspan>' +
    '<tspan x="6.91" y="0">ains</tspan><tspan class="cls-28" x="20.25" y="0">t</tspan><tspan class="cls-23" ' +
    'x="22.85" y="0">em</tspan></text>' +
    '</g>' +
    '<text class="cls-35" transform="translate(130.01 170.32)">B<tspan class="cls-34" x="4.34" y="0">r</tspan>' +
    '<tspan x="6.91" y="0">ains</tspan><tspan class="cls-28" x="20.25" y="0">t</tspan><tspan class="cls-23" ' +
    'x="22.85" y="0">em</tspan></text>' +
    '</g>' +
    '</g>' +
    '</svg>';

module.exports = {
  kolb_ch12_01: kolb_ch12_01,
  kolb_ch12_02: kolb_ch12_02,
  kolb_ch12_03: kolb_ch12_03
};


/***/ }),

/***/ 81:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(32);


/***/ })

},[81]);
//# sourceMappingURL=kolb_nia_winter2019_ch12_1.js.map

var SaviBcHandlers = SaviBcHandlers || {};

// slide 3
SaviBcHandlers.ended_6063891257001 = function(video_obj) {
  video_obj.watched = true;
  // uncomment this if the user is required to watch the video on slide 3
  // before moving on to next slide
  /*
  if (player.sections[2].task_completed) {
      player.completeSectionTask();
  }
  */
}

// slide 5
// this video does not have to be watched 
SaviBcHandlers.ended_3520954340001 = function(video_obj) {
  video_obj.watched = true;
}

var ArgaQueryText = ArgaQueryText || {};

ArgaQueryText['1a'] = 'Innervated by dopaminergic projections from the VTA, the ______  plays a role in the generation of voluntary movement.';
ArgaQueryText['1b'] = 'The ______  is the source of both the mesolimbic and mesocortical pathways.';
ArgaQueryText['1c'] = 'The ventral tegmentum is connected to the ______  via the mesocortical pathway.';
ArgaQueryText['1d'] = 'The mesolimbic pathway terminates in the';
ArgaQueryText['1e'] = 'The primary neurotransmitter in the mesolimbic pathway is';
